/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _155MP7JRSAUDIOSIGNALQUALITYTYPE_H
#define _155MP7JRSAUDIOSIGNALQUALITYTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioSignalQualityTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtInclude.h


#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDSType;
class IMp7JrsAudioSignalQualityType;
class IMp7JrsAudioSignalQualityType_ErrorEventList_LocalType;
class IMp7JrsBackgroundNoiseLevelType;
class IMp7JrsBalanceType;
class IMp7JrsBandwidthType;
class IMp7JrsCreationToolType;
class IMp7JrsCrossChannelCorrelationType;
class IMp7JrsDcOffsetType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsintegerVector;
class IMp7JrsmediaDurationType;
class IMp7JrsPersonType;
class IMp7JrsRelativeDelayType;
class IMp7JrsTransmissionTechnologyType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;
typedef Mp7JrsPtr< IMp7JrsAudioSignalQualityType_ErrorEventList_LocalType > Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsAudioSignalQualityType> Mp7JrsAudioSignalQualityPtr;
typedef Mp7JrsPtr< IMp7JrsBackgroundNoiseLevelType > Mp7JrsBackgroundNoiseLevelPtr;
typedef Mp7JrsPtr< IMp7JrsBalanceType > Mp7JrsBalancePtr;
typedef Mp7JrsPtr< IMp7JrsBandwidthType > Mp7JrsBandwidthPtr;
typedef Mp7JrsPtr< IMp7JrsCreationToolType > Mp7JrsCreationToolPtr;
typedef Mp7JrsPtr< IMp7JrsCrossChannelCorrelationType > Mp7JrsCrossChannelCorrelationPtr;
typedef Mp7JrsPtr< IMp7JrsDcOffsetType > Mp7JrsDcOffsetPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType > Mp7JrsPersonPtr;
typedef Mp7JrsPtr< IMp7JrsRelativeDelayType > Mp7JrsRelativeDelayPtr;
typedef Mp7JrsPtr< IMp7JrsTransmissionTechnologyType > Mp7JrsTransmissionTechnologyPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsAudioSignalQualityType for class Mp7JrsAudioSignalQualityType<br>
 * Located at: mpeg7-2004.xsd, line 2433<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioSignalQualityType 
 :
        public IMp7JrsAudioDSType
{
public:
    // TODO: make these protected?
    IMp7JrsAudioSignalQualityType();
    virtual ~IMp7JrsAudioSignalQualityType();
    /**
     * Get IsOriginalMono attribute.
     * @return bool
     */
    virtual bool GetIsOriginalMono() const = 0;

    /**
     * Get IsOriginalMono attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistIsOriginalMono() const = 0;

    /**
     * Set IsOriginalMono attribute.
     * @param item bool
     */
    virtual void SetIsOriginalMono(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate IsOriginalMono attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateIsOriginalMono() = 0;

    /**
     * Get BroadcastReady attribute.
     * @return bool
     */
    virtual bool GetBroadcastReady() const = 0;

    /**
     * Get BroadcastReady attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistBroadcastReady() const = 0;

    /**
     * Set BroadcastReady attribute.
     * @param item bool
     */
    virtual void SetBroadcastReady(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate BroadcastReady attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBroadcastReady() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Operator element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetOperator() const = 0;

    virtual bool IsValidOperator() const = 0;

    /**
     * Set Operator element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetOperator(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Operator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOperator() = 0;

    /**
     * Get UsedTool element.
     * @return Mp7JrsCreationToolPtr
     */
    virtual Mp7JrsCreationToolPtr GetUsedTool() const = 0;

    virtual bool IsValidUsedTool() const = 0;

    /**
     * Set UsedTool element.
     * @param item const Mp7JrsCreationToolPtr &
     */
    virtual void SetUsedTool(const Mp7JrsCreationToolPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate UsedTool element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateUsedTool() = 0;

    /**
     * Get BackgroundNoiseLevel element.
     * @return Mp7JrsBackgroundNoiseLevelPtr
     */
    virtual Mp7JrsBackgroundNoiseLevelPtr GetBackgroundNoiseLevel() const = 0;

    /**
     * Set BackgroundNoiseLevel element.
     * @param item const Mp7JrsBackgroundNoiseLevelPtr &
     */
    // Mandatory			
    virtual void SetBackgroundNoiseLevel(const Mp7JrsBackgroundNoiseLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RelativeDelay element.
     * @return Mp7JrsRelativeDelayPtr
     */
    virtual Mp7JrsRelativeDelayPtr GetRelativeDelay() const = 0;

    /**
     * Set RelativeDelay element.
     * @param item const Mp7JrsRelativeDelayPtr &
     */
    // Mandatory			
    virtual void SetRelativeDelay(const Mp7JrsRelativeDelayPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Balance element.
     * @return Mp7JrsBalancePtr
     */
    virtual Mp7JrsBalancePtr GetBalance() const = 0;

    /**
     * Set Balance element.
     * @param item const Mp7JrsBalancePtr &
     */
    // Mandatory			
    virtual void SetBalance(const Mp7JrsBalancePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DcOffset element.
     * @return Mp7JrsDcOffsetPtr
     */
    virtual Mp7JrsDcOffsetPtr GetDcOffset() const = 0;

    /**
     * Set DcOffset element.
     * @param item const Mp7JrsDcOffsetPtr &
     */
    // Mandatory			
    virtual void SetDcOffset(const Mp7JrsDcOffsetPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CrossChannelCorrelation element.
     * @return Mp7JrsCrossChannelCorrelationPtr
     */
    virtual Mp7JrsCrossChannelCorrelationPtr GetCrossChannelCorrelation() const = 0;

    /**
     * Set CrossChannelCorrelation element.
     * @param item const Mp7JrsCrossChannelCorrelationPtr &
     */
    // Mandatory			
    virtual void SetCrossChannelCorrelation(const Mp7JrsCrossChannelCorrelationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Bandwidth element.
     * @return Mp7JrsBandwidthPtr
     */
    virtual Mp7JrsBandwidthPtr GetBandwidth() const = 0;

    /**
     * Set Bandwidth element.
     * @param item const Mp7JrsBandwidthPtr &
     */
    // Mandatory			
    virtual void SetBandwidth(const Mp7JrsBandwidthPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TransmissionTechnology element.
     * @return Mp7JrsTransmissionTechnologyPtr
     */
    virtual Mp7JrsTransmissionTechnologyPtr GetTransmissionTechnology() const = 0;

    virtual bool IsValidTransmissionTechnology() const = 0;

    /**
     * Set TransmissionTechnology element.
     * @param item const Mp7JrsTransmissionTechnologyPtr &
     */
    virtual void SetTransmissionTechnology(const Mp7JrsTransmissionTechnologyPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate TransmissionTechnology element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTransmissionTechnology() = 0;

    /**
     * Get ErrorEventList element.
     * @return Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr
     */
    virtual Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr GetErrorEventList() const = 0;

    virtual bool IsValidErrorEventList() const = 0;

    /**
     * Set ErrorEventList element.
     * @param item const Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr &
     */
    virtual void SetErrorEventList(const Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate ErrorEventList element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateErrorEventList() = 0;

        //@}
    /**
     * Get channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDSType)
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr Getchannels() const = 0;

    /**
     * Get channels attribute validity information.
     * (Inherited from Mp7JrsAudioDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existchannels() const = 0;

    /**
     * Set channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDSType)
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate channels attribute.
     * (Inherited from Mp7JrsAudioDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatechannels() = 0;

    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of AudioSignalQualityType.
     * Currently this type contains 11 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>Operator</li>
     * <li>UsedTool</li>
     * <li>BackgroundNoiseLevel</li>
     * <li>RelativeDelay</li>
     * <li>Balance</li>
     * <li>DcOffset</li>
     * <li>CrossChannelCorrelation</li>
     * <li>Bandwidth</li>
     * <li>TransmissionTechnology</li>
     * <li>ErrorEventList</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioSignalQualityType<br>
 * Located at: mpeg7-2004.xsd, line 2433<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 2433.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioSignalQualityType :
        public IMp7JrsAudioSignalQualityType
{
    friend class Mp7JrsAudioSignalQualityTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsAudioSignalQualityType
     
     * @return Mp7JrsPtr< Mp7JrsAudioDSType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioDSType > GetBase() const;
    /*
     * Get IsOriginalMono attribute.
     * @return bool
     */
    virtual bool GetIsOriginalMono() const;

    /*
     * Get IsOriginalMono attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistIsOriginalMono() const;

    /*
     * Set IsOriginalMono attribute.
     * @param item bool
     */
    virtual void SetIsOriginalMono(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate IsOriginalMono attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateIsOriginalMono();

    /*
     * Get BroadcastReady attribute.
     * @return bool
     */
    virtual bool GetBroadcastReady() const;

    /*
     * Get BroadcastReady attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistBroadcastReady() const;

    /*
     * Set BroadcastReady attribute.
     * @param item bool
     */
    virtual void SetBroadcastReady(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate BroadcastReady attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateBroadcastReady();

        /* @name Sequence

         */
        //@{
    /*
     * Get Operator element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetOperator() const;

    virtual bool IsValidOperator() const;

    /*
     * Set Operator element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetOperator(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Operator element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateOperator();

    /*
     * Get UsedTool element.
     * @return Mp7JrsCreationToolPtr
     */
    virtual Mp7JrsCreationToolPtr GetUsedTool() const;

    virtual bool IsValidUsedTool() const;

    /*
     * Set UsedTool element.
     * @param item const Mp7JrsCreationToolPtr &
     */
    virtual void SetUsedTool(const Mp7JrsCreationToolPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate UsedTool element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateUsedTool();

    /*
     * Get BackgroundNoiseLevel element.
     * @return Mp7JrsBackgroundNoiseLevelPtr
     */
    virtual Mp7JrsBackgroundNoiseLevelPtr GetBackgroundNoiseLevel() const;

    /*
     * Set BackgroundNoiseLevel element.
     * @param item const Mp7JrsBackgroundNoiseLevelPtr &
     */
    // Mandatory			
    virtual void SetBackgroundNoiseLevel(const Mp7JrsBackgroundNoiseLevelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RelativeDelay element.
     * @return Mp7JrsRelativeDelayPtr
     */
    virtual Mp7JrsRelativeDelayPtr GetRelativeDelay() const;

    /*
     * Set RelativeDelay element.
     * @param item const Mp7JrsRelativeDelayPtr &
     */
    // Mandatory			
    virtual void SetRelativeDelay(const Mp7JrsRelativeDelayPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Balance element.
     * @return Mp7JrsBalancePtr
     */
    virtual Mp7JrsBalancePtr GetBalance() const;

    /*
     * Set Balance element.
     * @param item const Mp7JrsBalancePtr &
     */
    // Mandatory			
    virtual void SetBalance(const Mp7JrsBalancePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DcOffset element.
     * @return Mp7JrsDcOffsetPtr
     */
    virtual Mp7JrsDcOffsetPtr GetDcOffset() const;

    /*
     * Set DcOffset element.
     * @param item const Mp7JrsDcOffsetPtr &
     */
    // Mandatory			
    virtual void SetDcOffset(const Mp7JrsDcOffsetPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CrossChannelCorrelation element.
     * @return Mp7JrsCrossChannelCorrelationPtr
     */
    virtual Mp7JrsCrossChannelCorrelationPtr GetCrossChannelCorrelation() const;

    /*
     * Set CrossChannelCorrelation element.
     * @param item const Mp7JrsCrossChannelCorrelationPtr &
     */
    // Mandatory			
    virtual void SetCrossChannelCorrelation(const Mp7JrsCrossChannelCorrelationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Bandwidth element.
     * @return Mp7JrsBandwidthPtr
     */
    virtual Mp7JrsBandwidthPtr GetBandwidth() const;

    /*
     * Set Bandwidth element.
     * @param item const Mp7JrsBandwidthPtr &
     */
    // Mandatory			
    virtual void SetBandwidth(const Mp7JrsBandwidthPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TransmissionTechnology element.
     * @return Mp7JrsTransmissionTechnologyPtr
     */
    virtual Mp7JrsTransmissionTechnologyPtr GetTransmissionTechnology() const;

    virtual bool IsValidTransmissionTechnology() const;

    /*
     * Set TransmissionTechnology element.
     * @param item const Mp7JrsTransmissionTechnologyPtr &
     */
    virtual void SetTransmissionTechnology(const Mp7JrsTransmissionTechnologyPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate TransmissionTechnology element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTransmissionTechnology();

    /*
     * Get ErrorEventList element.
     * @return Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr
     */
    virtual Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr GetErrorEventList() const;

    virtual bool IsValidErrorEventList() const;

    /*
     * Set ErrorEventList element.
     * @param item const Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr &
     */
    virtual void SetErrorEventList(const Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate ErrorEventList element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateErrorEventList();

        //@}
    /*
     * Get channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDSType)
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr Getchannels() const;

    /*
     * Get channels attribute validity information.
     * (Inherited from Mp7JrsAudioDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existchannels() const;

    /*
     * Set channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDSType)
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate channels attribute.
     * (Inherited from Mp7JrsAudioDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatechannels();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of AudioSignalQualityType.
     * Currently this type contains 11 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>Operator</li>
     * <li>UsedTool</li>
     * <li>BackgroundNoiseLevel</li>
     * <li>RelativeDelay</li>
     * <li>Balance</li>
     * <li>DcOffset</li>
     * <li>CrossChannelCorrelation</li>
     * <li>Bandwidth</li>
     * <li>TransmissionTechnology</li>
     * <li>ErrorEventList</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioSignalQualityType();

protected:
    Mp7JrsAudioSignalQualityType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    bool m_IsOriginalMono;
    bool m_IsOriginalMono_Exist;
    bool m_BroadcastReady;
    bool m_BroadcastReady_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioDSType > m_Base;

    Mp7JrsPersonPtr m_Operator;
    bool m_Operator_Exist; // For optional elements 
    Mp7JrsCreationToolPtr m_UsedTool;
    bool m_UsedTool_Exist; // For optional elements 
    Mp7JrsBackgroundNoiseLevelPtr m_BackgroundNoiseLevel;
    Mp7JrsRelativeDelayPtr m_RelativeDelay;
    Mp7JrsBalancePtr m_Balance;
    Mp7JrsDcOffsetPtr m_DcOffset;
    Mp7JrsCrossChannelCorrelationPtr m_CrossChannelCorrelation;
    Mp7JrsBandwidthPtr m_Bandwidth;
    Mp7JrsTransmissionTechnologyPtr m_TransmissionTechnology;
    bool m_TransmissionTechnology_Exist; // For optional elements 
    Mp7JrsAudioSignalQualityType_ErrorEventList_LocalPtr m_ErrorEventList;
    bool m_ErrorEventList_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsAudioSignalQualityType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _155MP7JRSAUDIOSIGNALQUALITYTYPE_H

