/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _243MP7JRSAUDIOVISUALSEGMENTTYPE_LOCALTYPE_H
#define _243MP7JRSAUDIOVISUALSEGMENTTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAudioVisualSegmentType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentType_LocalType_ExtInclude.h


class IMp7JrsAudioVisualSegmentMediaSourceDecompositionType;
class IMp7JrsAudioVisualSegmentSpatialDecompositionType;
class IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType;
class IMp7JrsAudioVisualSegmentTemporalDecompositionType;
class IMp7JrsAudioVisualSegmentType_LocalType;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentMediaSourceDecompositionType > Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatialDecompositionType > Mp7JrsAudioVisualSegmentSpatialDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentSpatioTemporalDecompositionType > Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentTemporalDecompositionType > Mp7JrsAudioVisualSegmentTemporalDecompositionPtr;
typedef Mp7JrsPtr< IMp7JrsAudioVisualSegmentType_LocalType> Mp7JrsAudioVisualSegmentType_LocalPtr;

/** 
 * Generated interface IMp7JrsAudioVisualSegmentType_LocalType for class Mp7JrsAudioVisualSegmentType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAudioVisualSegmentType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAudioVisualSegmentType_LocalType();
    virtual ~IMp7JrsAudioVisualSegmentType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get SpatialDecomposition element.
     * @return Mp7JrsAudioVisualSegmentSpatialDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentSpatialDecompositionPtr GetSpatialDecomposition() const = 0;

    /**
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsAudioVisualSegmentSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TemporalDecomposition element.
     * @return Mp7JrsAudioVisualSegmentTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentTemporalDecompositionPtr GetTemporalDecomposition() const = 0;

    /**
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsAudioVisualSegmentTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const = 0;

    /**
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr GetMediaSourceDecomposition() const = 0;

    /**
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAudioVisualSegmentType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 6073.<br>
 */
class MP7JRS_EXPORT Mp7JrsAudioVisualSegmentType_LocalType :
        public IMp7JrsAudioVisualSegmentType_LocalType
{
    friend class Mp7JrsAudioVisualSegmentType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpatialDecomposition element.
     * @return Mp7JrsAudioVisualSegmentSpatialDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentSpatialDecompositionPtr GetSpatialDecomposition() const;

    /*
     * Set SpatialDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentSpatialDecompositionPtr &
     */
    virtual void SetSpatialDecomposition(const Mp7JrsAudioVisualSegmentSpatialDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TemporalDecomposition element.
     * @return Mp7JrsAudioVisualSegmentTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentTemporalDecompositionPtr GetTemporalDecomposition() const;

    /*
     * Set TemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentTemporalDecompositionPtr &
     */
    virtual void SetTemporalDecomposition(const Mp7JrsAudioVisualSegmentTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpatioTemporalDecomposition element.
     * @return Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr GetSpatioTemporalDecomposition() const;

    /*
     * Set SpatioTemporalDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr &
     */
    virtual void SetSpatioTemporalDecomposition(const Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaSourceDecomposition element.
     * @return Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr
     */
    virtual Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr GetMediaSourceDecomposition() const;

    /*
     * Set MediaSourceDecomposition element.
     * @param item const Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr &
     */
    virtual void SetMediaSourceDecomposition(const Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAudioVisualSegmentType_LocalType();

protected:
    Mp7JrsAudioVisualSegmentType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsAudioVisualSegmentSpatialDecompositionPtr m_SpatialDecomposition;
    Mp7JrsAudioVisualSegmentTemporalDecompositionPtr m_TemporalDecomposition;
    Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionPtr m_SpatioTemporalDecomposition;
    Mp7JrsAudioVisualSegmentMediaSourceDecompositionPtr m_MediaSourceDecomposition;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAudioVisualSegmentType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _243MP7JRSAUDIOVISUALSEGMENTTYPE_LOCALTYPE_H

