/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _413MP7JRSCLUSTERMODELTYPE_H
#define _413MP7JRSCLUSTERMODELTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsClusterModelTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsClusterModelType_ExtInclude.h


#include "Mp7JrsAnalyticModelType.h"
#include "Mp7JrsAnalyticModelType_function_LocalType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsModelType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAnalyticModelType;
class IMp7JrsAnalyticModelType_CollectionType;
class IMp7JrsClusterModelType;
class IMp7JrsClusterModelType_CollectionType;
class IMp7JrsClusterModelType_CollectionType0;
class IMp7JrsDescriptorModelType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsmediaDurationType;
class IMp7JrsProbabilityModelType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType > Mp7JrsAnalyticModelPtr;
typedef Mp7JrsPtr< IMp7JrsAnalyticModelType_CollectionType > Mp7JrsAnalyticModelType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClusterModelType_CollectionType > Mp7JrsClusterModelType_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsClusterModelType_CollectionType0 > Mp7JrsClusterModelType_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsClusterModelType> Mp7JrsClusterModelPtr;
typedef Mp7JrsPtr< IMp7JrsDescriptorModelType > Mp7JrsDescriptorModelPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsProbabilityModelType > Mp7JrsProbabilityModelPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsClusterModelType for class Mp7JrsClusterModelType<br>
 * Located at: mpeg7-2004.xsd, line 8303<br>
 * Classified: Class<br>
 * Derived from: AnalyticModelType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsClusterModelType 
 :
        public IMp7JrsAnalyticModelType
{
public:
    // TODO: make these protected?
    IMp7JrsClusterModelType();
    virtual ~IMp7JrsClusterModelType();
        /** @name Sequence

         */
        //@{
    /**
     * Get ClusterModelType_LocalType element.
     * @return Mp7JrsClusterModelType_CollectionPtr
     */
    virtual Mp7JrsClusterModelType_CollectionPtr GetClusterModelType_LocalType() const = 0;

    /**
     * Set ClusterModelType_LocalType element.
     * @param item const Mp7JrsClusterModelType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetClusterModelType_LocalType(const Mp7JrsClusterModelType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ClusterModelType_LocalType0 element.
     * @return Mp7JrsClusterModelType_Collection0Ptr
     */
    virtual Mp7JrsClusterModelType_Collection0Ptr GetClusterModelType_LocalType0() const = 0;

    /**
     * Set ClusterModelType_LocalType0 element.
     * @param item const Mp7JrsClusterModelType_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetClusterModelType_LocalType0(const Mp7JrsClusterModelType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get DescriptorModel element.
     * @return Mp7JrsDescriptorModelPtr
     */
    virtual Mp7JrsDescriptorModelPtr GetDescriptorModel() const = 0;

    /**
     * Set DescriptorModel element.
     * @param item const Mp7JrsDescriptorModelPtr &
     */
    // Mandatory			
    virtual void SetDescriptorModel(const Mp7JrsDescriptorModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ProbabilityModel element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProbabilityModel() const = 0;

    /**
     * Set ProbabilityModel element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    // Mandatory abstract element, possible types are
    // Mp7JrsBinomialDistributionPtr
    // Mp7JrsContinuousHiddenMarkovModelPtr
    // Mp7JrsContinuousUniformDistributionPtr
    // Mp7JrsDiscreteHiddenMarkovModelPtr
    // Mp7JrsDiscreteUniformDistributionPtr
    // Mp7JrsExponentialDistributionPtr
    // Mp7JrsGammaDistributionPtr
    // Mp7JrsGaussianDistributionPtr
    // Mp7JrsGaussianMixtureModelPtr
    // Mp7JrsGeneralizedGaussianDistributionPtr
    // Mp7JrsGeometricDistributionPtr
    // Mp7JrsHistogramProbabilityPtr
    // Mp7JrsHyperGeometricDistributionPtr
    // Mp7JrsLognormalDistributionPtr
    // Mp7JrsPoissonDistributionPtr
    // Mp7JrsProbabilityDistributionPtr
    // Mp7JrsSoundModelPtr
    // Mp7JrsStateTransitionModelPtr
    virtual void SetProbabilityModel(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
    /**
     * Get function attribute.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return Mp7JrsAnalyticModelType_function_LocalType::Enumeration
     */
    virtual Mp7JrsAnalyticModelType_function_LocalType::Enumeration Getfunction() const = 0;

    /**
     * Get function attribute validity information.
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfunction() const = 0;

    /**
     * Set function attribute.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @param item Mp7JrsAnalyticModelType_function_LocalType::Enumeration
     */
    virtual void Setfunction(Mp7JrsAnalyticModelType_function_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate function attribute.
     * (Inherited from Mp7JrsAnalyticModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefunction() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get AnalyticModelType_LocalType element.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return Mp7JrsAnalyticModelType_CollectionPtr
     */
    virtual Mp7JrsAnalyticModelType_CollectionPtr GetAnalyticModelType_LocalType() const = 0;

    /**
     * Set AnalyticModelType_LocalType element.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @param item const Mp7JrsAnalyticModelType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetAnalyticModelType_LocalType(const Mp7JrsAnalyticModelType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

    /**
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const = 0;

    /**
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const = 0;

    /**
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability() = 0;

    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of ClusterModelType.
     * Currently this type contains 9 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>Label</li>
     * <li>Semantics</li>
     * <li>Collection</li>
     * <li>CollectionRef</li>
     * <li>ClusterModel</li>
     * <li>ClusterModelRef</li>
     * <li>DescriptorModel</li>
     * <li>ProbabilityModel</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsClusterModelType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsClusterModelType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsClusterModelType<br>
 * Located at: mpeg7-2004.xsd, line 8303<br>
 * Classified: Class<br>
 * Derived from: AnalyticModelType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 8303.<br>
 */
class MP7JRS_EXPORT Mp7JrsClusterModelType :
        public IMp7JrsClusterModelType
{
    friend class Mp7JrsClusterModelTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsClusterModelType
     
     * @return Mp7JrsPtr< Mp7JrsAnalyticModelType >
     */
    virtual Mp7JrsPtr< Mp7JrsAnalyticModelType > GetBase() const;
        /* @name Sequence

         */
        //@{
    /*
     * Get ClusterModelType_LocalType element.
     * @return Mp7JrsClusterModelType_CollectionPtr
     */
    virtual Mp7JrsClusterModelType_CollectionPtr GetClusterModelType_LocalType() const;

    /*
     * Set ClusterModelType_LocalType element.
     * @param item const Mp7JrsClusterModelType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetClusterModelType_LocalType(const Mp7JrsClusterModelType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ClusterModelType_LocalType0 element.
     * @return Mp7JrsClusterModelType_Collection0Ptr
     */
    virtual Mp7JrsClusterModelType_Collection0Ptr GetClusterModelType_LocalType0() const;

    /*
     * Set ClusterModelType_LocalType0 element.
     * @param item const Mp7JrsClusterModelType_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetClusterModelType_LocalType0(const Mp7JrsClusterModelType_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get DescriptorModel element.
     * @return Mp7JrsDescriptorModelPtr
     */
    virtual Mp7JrsDescriptorModelPtr GetDescriptorModel() const;

    /*
     * Set DescriptorModel element.
     * @param item const Mp7JrsDescriptorModelPtr &
     */
    // Mandatory			
    virtual void SetDescriptorModel(const Mp7JrsDescriptorModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ProbabilityModel element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetProbabilityModel() const;

    /*
     * Set ProbabilityModel element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsBinomialDistributionPtr</li>
     * <li>IMp7JrsContinuousHiddenMarkovModelPtr</li>
     * <li>IMp7JrsContinuousUniformDistributionPtr</li>
     * <li>IMp7JrsDiscreteHiddenMarkovModelPtr</li>
     * <li>IMp7JrsDiscreteUniformDistributionPtr</li>
     * <li>IMp7JrsExponentialDistributionPtr</li>
     * <li>IMp7JrsGammaDistributionPtr</li>
     * <li>IMp7JrsGaussianDistributionPtr</li>
     * <li>IMp7JrsGaussianMixtureModelPtr</li>
     * <li>IMp7JrsGeneralizedGaussianDistributionPtr</li>
     * <li>IMp7JrsGeometricDistributionPtr</li>
     * <li>IMp7JrsHistogramProbabilityPtr</li>
     * <li>IMp7JrsHyperGeometricDistributionPtr</li>
     * <li>IMp7JrsLognormalDistributionPtr</li>
     * <li>IMp7JrsPoissonDistributionPtr</li>
     * <li>IMp7JrsProbabilityDistributionPtr</li>
     * <li>IMp7JrsSoundModelPtr</li>
     * <li>IMp7JrsStateTransitionModelPtr</li>
     * </ul>
     */
    // Mandatory abstract element, possible types are
    // Mp7JrsBinomialDistributionPtr
    // Mp7JrsContinuousHiddenMarkovModelPtr
    // Mp7JrsContinuousUniformDistributionPtr
    // Mp7JrsDiscreteHiddenMarkovModelPtr
    // Mp7JrsDiscreteUniformDistributionPtr
    // Mp7JrsExponentialDistributionPtr
    // Mp7JrsGammaDistributionPtr
    // Mp7JrsGaussianDistributionPtr
    // Mp7JrsGaussianMixtureModelPtr
    // Mp7JrsGeneralizedGaussianDistributionPtr
    // Mp7JrsGeometricDistributionPtr
    // Mp7JrsHistogramProbabilityPtr
    // Mp7JrsHyperGeometricDistributionPtr
    // Mp7JrsLognormalDistributionPtr
    // Mp7JrsPoissonDistributionPtr
    // Mp7JrsProbabilityDistributionPtr
    // Mp7JrsSoundModelPtr
    // Mp7JrsStateTransitionModelPtr
    virtual void SetProbabilityModel(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
    /*
     * Get function attribute.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return Mp7JrsAnalyticModelType_function_LocalType::Enumeration
     */
    virtual Mp7JrsAnalyticModelType_function_LocalType::Enumeration Getfunction() const;

    /*
     * Get function attribute validity information.
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existfunction() const;

    /*
     * Set function attribute.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @param item Mp7JrsAnalyticModelType_function_LocalType::Enumeration
     */
    virtual void Setfunction(Mp7JrsAnalyticModelType_function_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate function attribute.
     * (Inherited from Mp7JrsAnalyticModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatefunction();

        /* @name Sequence

         */
        //@{
    /*
     * Get AnalyticModelType_LocalType element.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @return Mp7JrsAnalyticModelType_CollectionPtr
     */
    virtual Mp7JrsAnalyticModelType_CollectionPtr GetAnalyticModelType_LocalType() const;

    /*
     * Set AnalyticModelType_LocalType element.
<br>
     * (Inherited from Mp7JrsAnalyticModelType)
     * @param item const Mp7JrsAnalyticModelType_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetAnalyticModelType_LocalType(const Mp7JrsAnalyticModelType_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

    /*
     * Get reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getreliability() const;

    /*
     * Get reliability attribute validity information.
     * (Inherited from Mp7JrsModelType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existreliability() const;

    /*
     * Set reliability attribute.
<br>
     * (Inherited from Mp7JrsModelType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setreliability(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate reliability attribute.
     * (Inherited from Mp7JrsModelType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatereliability();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of ClusterModelType.
     * Currently this type contains 9 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * <li>Label</li>
     * <li>Semantics</li>
     * <li>Collection</li>
     * <li>CollectionRef</li>
     * <li>ClusterModel</li>
     * <li>ClusterModelRef</li>
     * <li>DescriptorModel</li>
     * <li>ProbabilityModel</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsClusterModelType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsClusterModelType();

protected:
    Mp7JrsClusterModelType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAnalyticModelType > m_Base;

    Mp7JrsClusterModelType_CollectionPtr m_ClusterModelType_LocalType;
    Mp7JrsClusterModelType_Collection0Ptr m_ClusterModelType_LocalType0;
    Mp7JrsDescriptorModelPtr m_DescriptorModel;
    Mp7JrsPtr< Mp7JrsNode > m_ProbabilityModel;

// no includefile for extension defined 
// file Mp7JrsClusterModelType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _413MP7JRSCLUSTERMODELTYPE_H

