/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _636MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H
#define _636MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory<br>
 * for class Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType:<br>
 * Located at: mpeg7-2004.xsd, line 8204<br>
 * Abstract item type: ContinuousDistributionType<br>
 * Possible classes:<br>
 * \li ContinuousUniformDistributionType (Class)<br>
 * \li ExponentialDistributionType (Class)<br>
 * \li GammaDistributionType (Class)<br>
 * \li GaussianDistributionType (Class)<br>
 * \li GaussianMixtureModelType (Class)<br>
 * \li GeneralizedGaussianDistributionType (Class)<br>
 * \li LognormalDistributionType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory();
    virtual ~Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _636MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H
