/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// Include section of Mp7JrsFactory.h
#include "Mp7JrsUnknownFactory.h" // Handles unknown xsi:type elements

// IDREFS found
#include "Mp7JrsIDREFSFactory.h"

#include "Mp7JrsAbstractionLevelTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_CollectionTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CentralFourierFeature_LocalTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_CollectionTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_CompositeFeature_LocalTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_FourierFeature_CollectionTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_FourierFeature_LocalTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_CollectionTypeFactory.h"
#include "Mp7JrsAdvancedFaceRecognitionType_SubregionCompositeFeature_LocalTypeFactory.h"
#include "Mp7JrsAffectiveTypeFactory.h"
#include "Mp7JrsAffectiveType_Score_CollectionTypeFactory.h"
#include "Mp7JrsAffectiveType_Score_LocalTypeFactory.h"
#include "Mp7JrsAgentObjectTypeFactory.h"
#include "Mp7JrsAgentTypeFactory.h"
#include "Mp7JrsAgentType_Icon_CollectionTypeFactory.h"
#include "Mp7JrsAnalyticClipTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoSegmentTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoSegmentType_AnalyticEditionAreaDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsAnalyticEditedVideoTypeFactory.h"
#include "Mp7JrsAnalyticModelTypeFactory.h"
#include "Mp7JrsAnalyticModelType_CollectionTypeFactory.h"
#include "Mp7JrsAnalyticModelType_Label_LocalTypeFactory.h"
#include "Mp7JrsAnalyticModelType_LocalTypeFactory.h"
#include "Mp7JrsAnalyticModelType_Semantics_LocalTypeFactory.h"
#include "Mp7JrsAnalyticTransitionTypeFactory.h"
#include "Mp7JrsAudioBPMTypeFactory.h"
#include "Mp7JrsAudioDSTypeFactory.h"
#include "Mp7JrsAudioDTypeFactory.h"
#include "Mp7JrsAudioFundamentalFrequencyTypeFactory.h"
#include "Mp7JrsAudioHarmonicityTypeFactory.h"
#include "Mp7JrsAudioLLDScalarTypeFactory.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionTypeFactory.h"
#include "Mp7JrsAudioLLDScalarType_SeriesOfScalar_LocalTypeFactory.h"
#include "Mp7JrsAudioLLDVectorTypeFactory.h"
#include "Mp7JrsAudioLLDVectorType_SeriesOfVector_CollectionTypeFactory.h"
#include "Mp7JrsAudioLLDVectorType_SeriesOfVector_LocalTypeFactory.h"
#include "Mp7JrsAudioPowerTypeFactory.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioSegmentMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioSegmentTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioSegmentTypeFactory.h"
#include "Mp7JrsAudioSegmentType_CollectionTypeFactory.h"
#include "Mp7JrsAudioSegmentType_CollectionType0Factory.h"
#include "Mp7JrsAudioSegmentType_LocalTypeFactory.h"
#include "Mp7JrsAudioSegmentType_LocalType0Factory.h"
#include "Mp7JrsAudioSignalQualityTypeFactory.h"
#include "Mp7JrsAudioSignalQualityType_ErrorEventList_ErrorEvent_CollectionTypeFactory.h"
#include "Mp7JrsAudioSignalQualityType_ErrorEventList_LocalTypeFactory.h"
#include "Mp7JrsAudioSignatureTypeFactory.h"
#include "Mp7JrsAudioSpectrumBasisTypeFactory.h"
#include "Mp7JrsAudioSpectrumCentroidTypeFactory.h"
#include "Mp7JrsAudioSpectrumEnvelopeTypeFactory.h"
#include "Mp7JrsAudioSpectrumFlatnessTypeFactory.h"
#include "Mp7JrsAudioSpectrumProjectionTypeFactory.h"
#include "Mp7JrsAudioSpectrumSpreadTypeFactory.h"
#include "Mp7JrsAudioSummaryComponentTypeFactory.h"
#include "Mp7JrsAudioSummaryComponentType_Title_CollectionTypeFactory.h"
#include "Mp7JrsAudioTempoTypeFactory.h"
#include "Mp7JrsAudioTypeFactory.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualRegionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualRegionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentType_CollectionTypeFactory.h"
#include "Mp7JrsAudioVisualSegmentType_LocalTypeFactory.h"
#include "Mp7JrsAudioVisualTypeFactory.h"
#include "Mp7JrsAudioWaveformTypeFactory.h"
#include "Mp7JrsauxiliaryLanguageTypeFactory.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType0Factory.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType1Factory.h"
#include "Mp7JrsauxiliaryLanguageType_LocalType2Factory.h"
#include "Mp7JrsAvailabilityTypeFactory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_CollectionTypeFactory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_LocalTypeFactory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionTypeFactory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType0Factory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType1Factory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType2Factory.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType3Factory.h"
#include "Mp7JrsBackgroundNoiseLevelTypeFactory.h"
#include "Mp7JrsBalanceTypeFactory.h"
#include "Mp7JrsBandwidthTypeFactory.h"
#include "Mp7JrsbasicDurationTypeFactory.h"
#include "Mp7JrsbasicTimePointTypeFactory.h"
#include "Mp7JrsbeatTypeFactory.h"
#include "Mp7JrsBinomialDistributionTypeFactory.h"
#include "Mp7JrsBoxListTypeFactory.h"
#include "Mp7JrsBrowsingPreferencesTypeFactory.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionTypeFactory.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalTypeFactory.h"
#include "Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionTypeFactory.h"
#include "Mp7JrsCameraMotionSegmentTypeFactory.h"
#include "Mp7JrsCameraMotionTypeFactory.h"
#include "Mp7JrsCameraMotionType_Segment_CollectionTypeFactory.h"
#include "Mp7JrscharacterSetCodeFactory.h"
#include "Mp7JrsClassificationModelTypeFactory.h"
#include "Mp7JrsClassificationPreferencesTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_CaptionLanguage_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Country_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Country_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_DatePeriod_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_DatePeriod_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Form_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Form_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Genre_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Genre_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Language_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Language_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_LanguageFormat_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_ParentalGuidance_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Review_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Review_LocalTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Subject_CollectionTypeFactory.h"
#include "Mp7JrsClassificationPreferencesType_Subject_LocalTypeFactory.h"
#include "Mp7JrsClassificationSchemeAliasTypeFactory.h"
#include "Mp7JrsClassificationSchemeBaseTypeFactory.h"
#include "Mp7JrsClassificationSchemeBaseType_domain_CollectionTypeFactory.h"
#include "Mp7JrsClassificationSchemeBaseType_Import_CollectionTypeFactory.h"
#include "Mp7JrsClassificationSchemeDescriptionTypeFactory.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationScheme_CollectionTypeFactory.h"
#include "Mp7JrsClassificationSchemeDescriptionType_ClassificationSchemeBase_CollectionTypeFactory.h"
#include "Mp7JrsClassificationSchemeTypeFactory.h"
#include "Mp7JrsClassificationSchemeType_Term_CollectionTypeFactory.h"
#include "Mp7JrsClassificationTypeFactory.h"
#include "Mp7JrsClassificationType_CaptionLanguage_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_CaptionLanguage_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Genre_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_Genre_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Language_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_MediaReview_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_ParentalGuidance_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_Purpose_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_Release_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Release_Region_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_SignLanguage_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_SignLanguage_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Target_Age_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Target_LocalTypeFactory.h"
#include "Mp7JrsClassificationType_Target_Market_CollectionTypeFactory.h"
#include "Mp7JrsClassificationType_Target_Region_CollectionTypeFactory.h"
#include "Mp7JrsClusterClassificationModelTypeFactory.h"
#include "Mp7JrsClusterClassificationModelType_CollectionTypeFactory.h"
#include "Mp7JrsClusterClassificationModelType_LocalTypeFactory.h"
#include "Mp7JrsClusterModelTypeFactory.h"
#include "Mp7JrsClusterModelType_CollectionTypeFactory.h"
#include "Mp7JrsClusterModelType_CollectionType0Factory.h"
#include "Mp7JrsClusterModelType_LocalTypeFactory.h"
#include "Mp7JrsClusterModelType_LocalType0Factory.h"
#include "Mp7JrsCollectionModelTypeFactory.h"
#include "Mp7JrsCollectionModelType_CollectionTypeFactory.h"
#include "Mp7JrsCollectionModelType_LocalTypeFactory.h"
#include "Mp7JrsCollectionTypeFactory.h"
#include "Mp7JrsCollectionType_TextAnnotation_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff14_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff14_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff2_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff2_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff20_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff20_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff27_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff27_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff5_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff5_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff63_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff63_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff9_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CbACCoeff9_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff14_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff14_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff2_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff2_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff20_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff20_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff27_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff27_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff5_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff5_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff63_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff63_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff9_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_CrACCoeff9_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff14_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff14_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff2_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff2_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff20_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff20_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff27_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff27_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff5_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff5_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff63_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff63_LocalTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff9_CollectionTypeFactory.h"
#include "Mp7JrsColorLayoutType_YACCoeff9_LocalTypeFactory.h"
#include "Mp7JrsColorQuantizationTypeFactory.h"
#include "Mp7JrsColorQuantizationType_CollectionTypeFactory.h"
#include "Mp7JrsColorQuantizationType_LocalTypeFactory.h"
#include "Mp7JrsColorSamplingTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_CollectionTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_Component_CollectionTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_Component_LocalTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_Component_Offset_LocalTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_Component_Period_LocalTypeFactory.h"
#include "Mp7JrsColorSamplingType_Field_LocalTypeFactory.h"
#include "Mp7JrsColorSamplingType_Lattice_LocalTypeFactory.h"
#include "Mp7JrsColorSpaceTypeFactory.h"
#include "Mp7JrsColorSpaceType_ColorTransMat_CollectionTypeFactory.h"
#include "Mp7JrsColorSpaceType_ColorTransMat_LocalTypeFactory.h"
#include "Mp7JrsColorStructureTypeFactory.h"
#include "Mp7JrsColorStructureType_Values_CollectionTypeFactory.h"
#include "Mp7JrsColorStructureType_Values_LocalTypeFactory.h"
#include "Mp7JrsColorTemperatureTypeFactory.h"
#include "Mp7JrsCompleteDescriptionTypeFactory.h"
#include "Mp7JrsCompleteDescriptionType_OrderingKey_CollectionTypeFactory.h"
#include "Mp7JrsCompleteDescriptionType_Relationships_CollectionTypeFactory.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionTypeFactory.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsCompositionShotTypeFactory.h"
#include "Mp7JrsCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsCompositionTransitionTypeFactory.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType0Factory.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType1Factory.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType2Factory.h"
#include "Mp7JrsCompositionTransitionType_compositionType_LocalType3Factory.h"
#include "Mp7JrsConceptCollectionTypeFactory.h"
#include "Mp7JrsConceptCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsConceptCollectionType_CollectionType0Factory.h"
#include "Mp7JrsConceptCollectionType_LocalTypeFactory.h"
#include "Mp7JrsConceptCollectionType_LocalType0Factory.h"
#include "Mp7JrsConceptTypeFactory.h"
#include "Mp7JrsConfusionCountTypeFactory.h"
#include "Mp7JrsContentAbstractionTypeFactory.h"
#include "Mp7JrsContentCollectionTypeFactory.h"
#include "Mp7JrsContentCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsContentCollectionType_CollectionType0Factory.h"
#include "Mp7JrsContentCollectionType_CollectionType1Factory.h"
#include "Mp7JrsContentCollectionType_LocalTypeFactory.h"
#include "Mp7JrsContentCollectionType_LocalType0Factory.h"
#include "Mp7JrsContentCollectionType_LocalType1Factory.h"
#include "Mp7JrsContentDescriptionTypeFactory.h"
#include "Mp7JrsContentDescriptionType_Affective_CollectionTypeFactory.h"
#include "Mp7JrsContentEntityTypeFactory.h"
#include "Mp7JrsContentEntityType_MultimediaContent_CollectionTypeFactory.h"
#include "Mp7JrsContentManagementTypeFactory.h"
#include "Mp7JrsContinuousDistributionTypeFactory.h"
#include "Mp7JrsContinuousHiddenMarkovModelTypeFactory.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_DescriptorModel_CollectionTypeFactory.h"
#include "Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory.h"
#include "Mp7JrsContinuousUniformDistributionTypeFactory.h"
#include "Mp7JrsContourShapeTypeFactory.h"
#include "Mp7JrsContourShapeType_Peak_CollectionTypeFactory.h"
#include "Mp7JrsContourShapeType_Peak_LocalTypeFactory.h"
#include "Mp7JrscontourTypeFactory.h"
#include "Mp7JrscontourType_LocalTypeFactory.h"
#include "Mp7JrsControlledTermUseTypeFactory.h"
#include "Mp7JrscountryCodeFactory.h"
#include "Mp7JrsCreationDescriptionTypeFactory.h"
#include "Mp7JrsCreationDescriptionType_CreationInformation_CollectionTypeFactory.h"
#include "Mp7JrsCreationInformationTypeFactory.h"
#include "Mp7JrsCreationInformationType_RelatedMaterial_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Creator_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Creator_LocalTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_DatePeriod_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_DatePeriod_LocalTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Keyword_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Keyword_LocalTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Location_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Location_LocalTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Title_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Title_LocalTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Tool_CollectionTypeFactory.h"
#include "Mp7JrsCreationPreferencesType_Tool_LocalTypeFactory.h"
#include "Mp7JrsCreationToolTypeFactory.h"
#include "Mp7JrsCreationToolType_Setting_CollectionTypeFactory.h"
#include "Mp7JrsCreationToolType_Setting_LocalTypeFactory.h"
#include "Mp7JrsCreationTypeFactory.h"
#include "Mp7JrsCreationType_Abstract_CollectionTypeFactory.h"
#include "Mp7JrsCreationType_CopyrightString_CollectionTypeFactory.h"
#include "Mp7JrsCreationType_CreationCoordinates_CollectionTypeFactory.h"
#include "Mp7JrsCreationType_CreationCoordinates_LocalTypeFactory.h"
#include "Mp7JrsCreationType_CreationTool_CollectionTypeFactory.h"
#include "Mp7JrsCreationType_Creator_CollectionTypeFactory.h"
#include "Mp7JrsCreationType_Title_CollectionTypeFactory.h"
#include "Mp7JrsCreatorTypeFactory.h"
#include "Mp7JrsCreatorType_Character_CollectionTypeFactory.h"
#include "Mp7JrsCreatorType_Instrument_CollectionTypeFactory.h"
#include "Mp7JrsCrossChannelCorrelationTypeFactory.h"
#include "Mp7JrscurrencyCodeFactory.h"
#include "Mp7JrscurvatureTypeFactory.h"
#include "Mp7JrscurvatureType_CollectionTypeFactory.h"
#include "Mp7JrsDcOffsetTypeFactory.h"
#include "Mp7JrsdependencyOperatorTypeFactory.h"
#include "Mp7JrsDependencyStructurePhraseTypeFactory.h"
#include "Mp7JrsDependencyStructurePhraseType_CollectionTypeFactory.h"
#include "Mp7JrsDependencyStructurePhraseType_CollectionType0Factory.h"
#include "Mp7JrsDependencyStructurePhraseType_LocalTypeFactory.h"
#include "Mp7JrsDependencyStructurePhraseType_LocalType0Factory.h"
#include "Mp7JrsDependencyStructurePhraseType_operator_LocalTypeFactory.h"
#include "Mp7JrsDependencyStructureTypeFactory.h"
#include "Mp7JrsDependencyStructureType_Sentence_CollectionTypeFactory.h"
#include "Mp7JrsDescriptionMetadataTypeFactory.h"
#include "Mp7JrsDescriptionMetadataType_Creator_CollectionTypeFactory.h"
#include "Mp7JrsDescriptionMetadataType_Instrument_CollectionTypeFactory.h"
#include "Mp7JrsDescriptionMetadataType_PrivateIdentifier_CollectionTypeFactory.h"
#include "Mp7JrsDescriptionMetadataType_PublicIdentifier_CollectionTypeFactory.h"
#include "Mp7JrsDescriptorCollectionTypeFactory.h"
#include "Mp7JrsDescriptorCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsDescriptorCollectionType_Descriptor_CollectionTypeFactory.h"
#include "Mp7JrsDescriptorCollectionType_LocalTypeFactory.h"
#include "Mp7JrsDescriptorModelTypeFactory.h"
#include "Mp7JrsDescriptorModelType_Field_CollectionTypeFactory.h"
#include "Mp7Jrsdim_LocalTypeFactory.h"
#include "Mp7JrsDiscreteDistributionTypeFactory.h"
#include "Mp7JrsDiscreteHiddenMarkovModelTypeFactory.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_CollectionTypeFactory.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_LocalTypeFactory.h"
#include "Mp7JrsDiscreteHiddenMarkovModelType_Observation_CollectionTypeFactory.h"
#include "Mp7JrsDiscreteUniformDistributionTypeFactory.h"
#include "Mp7JrsDisseminationTypeFactory.h"
#include "Mp7JrsDominantColorTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_CollectionTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_ColorVariance_CollectionTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_ColorVariance_LocalTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_Index_CollectionTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_Index_LocalTypeFactory.h"
#include "Mp7JrsDominantColorType_Value_LocalTypeFactory.h"
#include "Mp7JrsDoubleDiagonalMatrixTypeFactory.h"
#include "Mp7JrsDoubleMatrixTypeFactory.h"
#include "Mp7JrsDoublePullbackDefinitionTypeFactory.h"
#include "Mp7JrsDoublePullbackDefinitionType_MorphismGraph_CollectionTypeFactory.h"
#include "Mp7JrsDoublePullbackDefinitionType_RuleGraph_CollectionTypeFactory.h"
#include "Mp7JrsDoublePushoutDefinitionTypeFactory.h"
#include "Mp7JrsDoublePushoutDefinitionType_MorphismGraph_CollectionTypeFactory.h"
#include "Mp7JrsdoubleVectorFactory.h"
#include "Mp7JrsDSTypeFactory.h"
#include "Mp7JrsDSType_Header_CollectionTypeFactory.h"
#include "Mp7JrsDTypeFactory.h"
#include "Mp7JrsdurationTypeFactory.h"
#include "Mp7JrsEdgeHistogramTypeFactory.h"
#include "Mp7JrsEdgeHistogramType_BinCounts_CollectionTypeFactory.h"
#include "Mp7JrsEdgeHistogramType_BinCounts_LocalTypeFactory.h"
#include "Mp7JrsEditedMovingRegionTypeFactory.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionTypeFactory.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsEditedVideoTypeFactory.h"
#include "Mp7JrsEditedVideoType_AnalyticEditingTemporalDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsElectronicAddressTypeFactory.h"
#include "Mp7JrsElectronicAddressType_Email_CollectionTypeFactory.h"
#include "Mp7JrsElectronicAddressType_Fax_CollectionTypeFactory.h"
#include "Mp7JrsElectronicAddressType_Telephone_CollectionTypeFactory.h"
#include "Mp7JrsElectronicAddressType_Url_CollectionTypeFactory.h"
#include "Mp7JrsErrorEventTypeFactory.h"
#include "Mp7JrsEventTypeFactory.h"
#include "Mp7JrsEventType_CollectionTypeFactory.h"
#include "Mp7JrsEventType_LocalTypeFactory.h"
#include "Mp7JrsEventType_SemanticPlace_CollectionTypeFactory.h"
#include "Mp7JrsEventType_SemanticTime_CollectionTypeFactory.h"
#include "Mp7JrsExponentialDistributionTypeFactory.h"
#include "Mp7JrsExtendedLanguageTypeFactory.h"
#include "Mp7JrsExtentTypeFactory.h"
#include "Mp7JrsFaceRecognitionTypeFactory.h"
#include "Mp7JrsFaceRecognitionType_Feature_CollectionTypeFactory.h"
#include "Mp7JrsFaceRecognitionType_Feature_LocalTypeFactory.h"
#include "Mp7JrsFigureTrajectoryTypeFactory.h"
#include "Mp7JrsFigureTrajectoryType_Vertex_CollectionTypeFactory.h"
#include "Mp7JrsFilter1DTypeFactory.h"
#include "Mp7JrsFilter2DTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_ClassificationPreferences_CollectionTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_CreationPreferences_CollectionTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_FilteringAndSearchPreferences_CollectionTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_PreferenceCondition_CollectionTypeFactory.h"
#include "Mp7JrsFilteringAndSearchPreferencesType_SourcePreferences_CollectionTypeFactory.h"
#include "Mp7JrsFilteringTypeFactory.h"
#include "Mp7JrsFilterSeparableTypeFactory.h"
#include "Mp7JrsFilterSeparableType_Filter1D_CollectionTypeFactory.h"
#include "Mp7JrsFilterTypeFactory.h"
#include "Mp7JrsFinancialTypeFactory.h"
#include "Mp7JrsFinancialType_AccountItem_CollectionTypeFactory.h"
#include "Mp7JrsFinancialType_AccountItem_LocalTypeFactory.h"
#include "Mp7JrsFiniteStateModelTypeFactory.h"
#include "Mp7JrsFloatDiagonalMatrixTypeFactory.h"
#include "Mp7JrsFloatMatrixTypeFactory.h"
#include "Mp7JrsfloatVectorFactory.h"
#include "Mp7JrsFocusOfExpansionTypeFactory.h"
#include "Mp7JrsFractionalPresenceTypeFactory.h"
#include "Mp7JrsFrequencyTreeTypeFactory.h"
#include "Mp7JrsFrequencyTreeType_CollectionTypeFactory.h"
#include "Mp7JrsFrequencyTreeType_LocalTypeFactory.h"
#include "Mp7JrsFrequencyViewTypeFactory.h"
#include "Mp7JrsGammaDistributionTypeFactory.h"
#include "Mp7JrsGaussianDistributionTypeFactory.h"
#include "Mp7JrsGaussianMixtureModelTypeFactory.h"
#include "Mp7JrsGaussianMixtureModelType_CollectionTypeFactory.h"
#include "Mp7JrsGaussianMixtureModelType_LocalTypeFactory.h"
#include "Mp7JrsGeneralizedGaussianDistributionTypeFactory.h"
#include "Mp7JrsGeneralRelationTypeFactory.h"
#include "Mp7JrsGeographicPointTypeFactory.h"
#include "Mp7JrsGeographicPointType_latitude_LocalTypeFactory.h"
#include "Mp7JrsGeographicPointType_longitude_LocalTypeFactory.h"
#include "Mp7JrsGeometricDistributionTypeFactory.h"
#include "Mp7JrsGlobalTransitionTypeFactory.h"
#include "Mp7JrsGoFGoPColorTypeFactory.h"
#include "Mp7JrsGopGofFeatureFactory.h"
#include "Mp7JrsGraphicalClassificationSchemeTypeFactory.h"
#include "Mp7JrsGraphicalClassificationSchemeType_GraphicalTerm_CollectionTypeFactory.h"
#include "Mp7JrsGraphicalRuleDefinitionTypeFactory.h"
#include "Mp7JrsGraphicalTermDefinitionTypeFactory.h"
#include "Mp7JrsGraphTypeFactory.h"
#include "Mp7JrsGraphType_CollectionTypeFactory.h"
#include "Mp7JrsGraphType_LocalTypeFactory.h"
#include "Mp7JrsGraphType_Node_LocalTypeFactory.h"
#include "Mp7JrsGridLayoutTypeFactory.h"
#include "Mp7JrsGridLayoutType_Descriptor_CollectionTypeFactory.h"
#include "Mp7JrsGridLayoutType_descriptorMask_LocalTypeFactory.h"
#include "Mp7JrsHandWritingRecogInformationTypeFactory.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_CollectionTypeFactory.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_Entry_LocalTypeFactory.h"
#include "Mp7JrsHandWritingRecogInformationType_InkLexicon_LocalTypeFactory.h"
#include "Mp7JrsHandWritingRecogInformationType_Recognizer_LocalTypeFactory.h"
#include "Mp7JrsHandWritingRecogResultTypeFactory.h"
#include "Mp7JrsHandWritingRecogResultType_Result_CollectionTypeFactory.h"
#include "Mp7JrsHandWritingRecogResultType_Result_LocalTypeFactory.h"
#include "Mp7JrsHarmonicInstrumentTimbreTypeFactory.h"
#include "Mp7JrsHarmonicSpectralCentroidTypeFactory.h"
#include "Mp7JrsHarmonicSpectralDeviationTypeFactory.h"
#include "Mp7JrsHarmonicSpectralSpreadTypeFactory.h"
#include "Mp7JrsHarmonicSpectralVariationTypeFactory.h"
#include "Mp7JrsHeaderTypeFactory.h"
#include "Mp7JrsHierarchicalSummaryTypeFactory.h"
#include "Mp7JrsHierarchicalSummaryType_CollectionTypeFactory.h"
#include "Mp7JrsHierarchicalSummaryType_components_CollectionTypeFactory.h"
#include "Mp7JrsHierarchicalSummaryType_LocalTypeFactory.h"
#include "Mp7JrsHistogramProbabilityTypeFactory.h"
#include "Mp7JrsHomogeneousTextureTypeFactory.h"
#include "Mp7JrsHyperGeometricDistributionTypeFactory.h"
#include "Mp7JrsIlluminationInvariantColorTypeFactory.h"
#include "Mp7JrsImageLocatorTypeFactory.h"
#include "Mp7JrsImageLocatorType_BytePosition_LocalTypeFactory.h"
#include "Mp7JrsImageTextTypeFactory.h"
#include "Mp7JrsImageTextType_textType_LocalType0Factory.h"
#include "Mp7JrsImageTextType_textType_LocalType1Factory.h"
#include "Mp7JrsImageTextType_textType_LocalType2Factory.h"
#include "Mp7JrsImageTextType_textType_LocalType3Factory.h"
#include "Mp7JrsImageTypeFactory.h"
#include "Mp7JrsIncrDurationTypeFactory.h"
#include "Mp7JrsInkContentTypeFactory.h"
#include "Mp7JrsInkMediaInformationTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_Brush_CollectionTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_Brush_LocalTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_CollectionTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_OverlaidMedia_LocalTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_Param_CollectionTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_Param_LocalTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType0Factory.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType1Factory.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType2Factory.h"
#include "Mp7JrsInkMediaInformationType_Style_LocalType3Factory.h"
#include "Mp7JrsInkMediaInformationType_WritingFieldLayout_fieldIDList_CollectionTypeFactory.h"
#include "Mp7JrsInkMediaInformationType_WritingFieldLayout_LocalTypeFactory.h"
#include "Mp7JrsInkSegmentSpatialDecompositionTypeFactory.h"
#include "Mp7JrsInkSegmentSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsInkSegmentSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsInkSegmentTemporalDecompositionTypeFactory.h"
#include "Mp7JrsInkSegmentTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsInkSegmentTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsInkSegmentTypeFactory.h"
#include "Mp7JrsInkSegmentType_CollectionTypeFactory.h"
#include "Mp7JrsInkSegmentType_CollectionType0Factory.h"
#include "Mp7JrsInkSegmentType_CollectionType1Factory.h"
#include "Mp7JrsInkSegmentType_LocalTypeFactory.h"
#include "Mp7JrsInkSegmentType_LocalType0Factory.h"
#include "Mp7JrsInkSegmentType_LocalType1Factory.h"
#include "Mp7JrsInlineMediaTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionTypeFactory.h"
#include "Mp7JrsInlineTermDefinitionType_Term_LocalTypeFactory.h"
#include "Mp7JrsInstrumentTimbreTypeFactory.h"
#include "Mp7JrsIntegerDiagonalMatrixTypeFactory.h"
#include "Mp7JrsIntegerMatrixTypeFactory.h"
#include "Mp7JrsintegerVectorFactory.h"
#include "Mp7JrsInternalTransitionTypeFactory.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionTypeFactory.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsIntraCompositionShotTypeFactory.h"
#include "Mp7JrsIntraCompositionShotType_AnalyticEditingTemporalDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsIrregularVisualTimeSeriesTypeFactory.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_CollectionTypeFactory.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_LocalTypeFactory.h"
#include "Mp7JrsKeyTypeFactory.h"
#include "Mp7JrsKeyType_KeyNote_LocalTypeFactory.h"
#include "Mp7JrsKeywordAnnotationTypeFactory.h"
#include "Mp7JrsKeywordAnnotationType_Keyword_CollectionTypeFactory.h"
#include "Mp7JrsKeywordAnnotationType_Keyword_LocalTypeFactory.h"
#include "Mp7JrsLexiconTypeFactory.h"
#include "Mp7JrsLinguisticDocumentTypeFactory.h"
#include "Mp7JrsLinguisticDocumentType_CollectionTypeFactory.h"
#include "Mp7JrsLinguisticDocumentType_LocalTypeFactory.h"
#include "Mp7JrsLinguisticEntityTypeFactory.h"
#include "Mp7JrsLinguisticEntityType_edit_LocalTypeFactory.h"
#include "Mp7JrsLinguisticEntityType_length_LocalTypeFactory.h"
#include "Mp7JrsLinguisticEntityType_MediaLocator_CollectionTypeFactory.h"
#include "Mp7JrsLinguisticEntityType_Relation_CollectionTypeFactory.h"
#include "Mp7JrsLinguisticEntityType_start_LocalTypeFactory.h"
#include "Mp7JrsLinguisticTypeFactory.h"
#include "Mp7JrslistOfPositiveIntegerForDimFactory.h"
#include "Mp7JrsLogAttackTimeTypeFactory.h"
#include "Mp7JrsLognormalDistributionTypeFactory.h"
#include "Mp7JrsMaskTypeFactory.h"
#include "Mp7JrsMatchingHintTypeFactory.h"
#include "Mp7JrsMatchingHintType_Hint_CollectionTypeFactory.h"
#include "Mp7JrsMatchingHintType_Hint_LocalTypeFactory.h"
#include "Mp7JrsMediaAgentTypeFactory.h"
#include "Mp7JrsMediaDescriptionTypeFactory.h"
#include "Mp7JrsMediaDescriptionType_MediaInformation_CollectionTypeFactory.h"
#include "Mp7JrsmediaDurationTypeFactory.h"
#include "Mp7JrsMediaFormatTypeFactory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType0Factory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType1Factory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2Factory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType3Factory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Sample_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_BitRate_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType0Factory.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType1Factory.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType2Factory.h"
#include "Mp7JrsMediaFormatType_ScalableCoding_LocalType3Factory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType0Factory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType1Factory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType2Factory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_colorDomain_LocalType3Factory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Format_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Frame_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_LocalTypeFactory.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Pixel_LocalTypeFactory.h"
#include "Mp7JrsMediaIdentificationTypeFactory.h"
#include "Mp7JrsMediaIdentificationType_AudioDomain_CollectionTypeFactory.h"
#include "Mp7JrsMediaIdentificationType_ImageDomain_CollectionTypeFactory.h"
#include "Mp7JrsMediaIdentificationType_VideoDomain_CollectionTypeFactory.h"
#include "Mp7JrsMediaIncrDurationTypeFactory.h"
#include "Mp7JrsMediaInformationTypeFactory.h"
#include "Mp7JrsMediaInformationType_MediaProfile_CollectionTypeFactory.h"
#include "Mp7JrsMediaInstanceTypeFactory.h"
#include "Mp7JrsMediaLocatorTypeFactory.h"
#include "Mp7JrsMediaProfileTypeFactory.h"
#include "Mp7JrsMediaProfileType_ComponentMediaProfile_CollectionTypeFactory.h"
#include "Mp7JrsMediaProfileType_MediaInstance_CollectionTypeFactory.h"
#include "Mp7JrsMediaQualityTypeFactory.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_AudioDefects_CollectionTypeFactory.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_LocalTypeFactory.h"
#include "Mp7JrsMediaQualityType_PerceptibleDefects_VisualDefects_CollectionTypeFactory.h"
#include "Mp7JrsMediaQualityType_QualityRating_CollectionTypeFactory.h"
#include "Mp7JrsMediaQualityType_QualityRating_LocalTypeFactory.h"
#include "Mp7JrsMediaQualityType_RatingInformationLocator_CollectionTypeFactory.h"
#include "Mp7JrsMediaRelIncrTimePointTypeFactory.h"
#include "Mp7JrsMediaRelTimePointTypeFactory.h"
#include "Mp7JrsMediaReviewTypeFactory.h"
#include "Mp7JrsMediaReviewType_FreeTextReview_CollectionTypeFactory.h"
#include "Mp7JrsMediaSourceSegmentDecompositionTypeFactory.h"
#include "Mp7JrsMediaSpaceMaskTypeFactory.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_CollectionTypeFactory.h"
#include "Mp7JrsMediaSpaceMaskType_SubInterval_LocalTypeFactory.h"
#include "Mp7JrsmediaTimeOffsetTypeFactory.h"
#include "Mp7JrsmediaTimePointTypeFactory.h"
#include "Mp7JrsMediaTimeTypeFactory.h"
#include "Mp7JrsMediaTranscodingHintsTypeFactory.h"
#include "Mp7JrsMediaTranscodingHintsType_CodingHints_LocalTypeFactory.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_LocalTypeFactory.h"
#include "Mp7JrsMediaTranscodingHintsType_MotionHint_MotionRange_LocalTypeFactory.h"
#include "Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalTypeFactory.h"
#include "Mp7JrsMelodyContourTypeFactory.h"
#include "Mp7JrsMelodySequenceTypeFactory.h"
#include "Mp7JrsMelodySequenceType_NoteArray_CollectionTypeFactory.h"
#include "Mp7JrsMelodySequenceType_NoteArray_LocalTypeFactory.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_CollectionTypeFactory.h"
#include "Mp7JrsMelodySequenceType_NoteArray_Note_LocalTypeFactory.h"
#include "Mp7JrsMelodySequenceType_StartingNote_LocalTypeFactory.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_LocalTypeFactory.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalTypeFactory.h"
#include "Mp7JrsMelodyTypeFactory.h"
#include "Mp7JrsMelodyType_MelodySequence_CollectionTypeFactory.h"
#include "Mp7JrsMeterTypeFactory.h"
#include "Mp7JrsMeterType_Numerator_LocalTypeFactory.h"
#include "Mp7JrsmimeTypeFactory.h"
#include "Mp7JrsMinusOneToOneMatrixTypeFactory.h"
#include "Mp7JrsminusOneToOneTypeFactory.h"
#include "Mp7JrsminusOneToOneVectorFactory.h"
#include "Mp7JrsminusOneToOneVector_LocalTypeFactory.h"
#include "Mp7JrsMixedCollectionTypeFactory.h"
#include "Mp7JrsMixedCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsMixedCollectionType_CollectionType0Factory.h"
#include "Mp7JrsMixedCollectionType_CollectionType1Factory.h"
#include "Mp7JrsMixedCollectionType_CollectionType2Factory.h"
#include "Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory.h"
#include "Mp7JrsMixedCollectionType_LocalTypeFactory.h"
#include "Mp7JrsMixedCollectionType_LocalType0Factory.h"
#include "Mp7JrsMixedCollectionType_LocalType1Factory.h"
#include "Mp7JrsMixedCollectionType_LocalType2Factory.h"
#include "Mp7JrsMixtureAmountOfMotionTypeFactory.h"
#include "Mp7JrsMixtureCameraMotionSegmentTypeFactory.h"
#include "Mp7JrsModelDescriptionTypeFactory.h"
#include "Mp7JrsModelDescriptionType_Model_CollectionTypeFactory.h"
#include "Mp7JrsModelStateTypeFactory.h"
#include "Mp7JrsModelTypeFactory.h"
#include "Mp7JrsMorphismGraphTypeFactory.h"
#include "Mp7JrsMosaicTypeFactory.h"
#include "Mp7JrsMosaicType_WarpingParam_CollectionTypeFactory.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalTypeFactory.h"
#include "Mp7JrsMosaicType_WarpingParam_LocalType0Factory.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType0Factory.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType1Factory.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType2Factory.h"
#include "Mp7JrsMosaicType_WarpingParam_modelType_LocalType3Factory.h"
#include "Mp7JrsMotionActivityTypeFactory.h"
#include "Mp7JrsMotionActivityType_Intensity_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialDistributionParams_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_CollectionTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector16_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_CollectionTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector256_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_CollectionTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector4_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_CollectionTypeFactory.h"
#include "Mp7JrsMotionActivityType_SpatialLocalizationParams_Vector64_LocalTypeFactory.h"
#include "Mp7JrsMotionActivityType_TemporalParams_CollectionTypeFactory.h"
#include "Mp7JrsMotionActivityType_TemporalParams_LocalTypeFactory.h"
#include "Mp7JrsMotionTrajectoryTypeFactory.h"
#include "Mp7JrsMotionTrajectoryType_CoordDef_LocalTypeFactory.h"
#include "Mp7JrsMotionTrajectoryType_CoordDef_Repr_LocalTypeFactory.h"
#include "Mp7JrsMotionTrajectoryType_CoordRef_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionFeatureTypeFactory.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionSpatialDecompositionTypeFactory.h"
#include "Mp7JrsMovingRegionSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsMovingRegionSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionTypeFactory.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionTemporalDecompositionTypeFactory.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionTypeFactory.h"
#include "Mp7JrsMovingRegionType_CollectionTypeFactory.h"
#include "Mp7JrsMovingRegionType_CollectionType0Factory.h"
#include "Mp7JrsMovingRegionType_LocalTypeFactory.h"
#include "Mp7JrsMovingRegionType_LocalType0Factory.h"
#include "Mp7JrsMpeg7_Description_CollectionTypeFactory.h"
#include "Mp7JrsMpeg7_LocalTypeFactory.h"
#include "Mp7JrsMpeg7BaseTypeFactory.h"
#include "Mp7JrsMpeg7TypeFactory.h"
#include "Mp7JrsMultimediaCollectionTypeFactory.h"
#include "Mp7JrsMultimediaCollectionType_Collection_CollectionTypeFactory.h"
#include "Mp7JrsMultimediaCollectionType_StructuredCollection_CollectionTypeFactory.h"
#include "Mp7JrsMultimediaContentTypeFactory.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsMultimediaSegmentMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsMultimediaSegmentTypeFactory.h"
#include "Mp7JrsMultimediaSegmentType_MediaSourceDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsMultimediaTypeFactory.h"
#include "Mp7JrsMultipleViewTypeFactory.h"
#include "Mp7JrsMultipleViewType_CollectionTypeFactory.h"
#include "Mp7JrsMultipleViewType_LocalTypeFactory.h"
#include "Mp7JrsMultiResolutionPyramidTypeFactory.h"
#include "Mp7JrsNameComponentTypeFactory.h"
#include "Mp7JrsNonDependencyStructurePhraseTypeFactory.h"
#include "Mp7JrsNonDependencyStructurePhraseType_CollectionTypeFactory.h"
#include "Mp7JrsNonDependencyStructurePhraseType_LocalTypeFactory.h"
#include "Mp7JrsNonMixtureAmountOfMotionTypeFactory.h"
#include "Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalTypeFactory.h"
#include "Mp7JrsNonMixtureCameraMotionSegmentTypeFactory.h"
#include "Mp7JrsnonNegativeRealFactory.h"
#include "Mp7JrsObjectTypeFactory.h"
#include "Mp7JrsObjectType_CollectionTypeFactory.h"
#include "Mp7JrsObjectType_LocalTypeFactory.h"
#include "Mp7JrsOrderedGroupDataSetMaskTypeFactory.h"
#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_CollectionTypeFactory.h"
#include "Mp7JrsOrderedGroupDataSetMaskType_SubInterval_LocalTypeFactory.h"
#include "Mp7JrsOrderingKeyTypeFactory.h"
#include "Mp7JrsOrderingKeyType_Field_CollectionTypeFactory.h"
#include "Mp7JrsOrderingKeyType_Field_LocalTypeFactory.h"
#include "Mp7JrsOrderingKeyType_Selector_LocalTypeFactory.h"
#include "Mp7JrsOrganizationTypeFactory.h"
#include "Mp7JrsOrganizationType_CollectionTypeFactory.h"
#include "Mp7JrsOrganizationType_LocalTypeFactory.h"
#include "Mp7JrsOrganizationType_Name_CollectionTypeFactory.h"
#include "Mp7JrsOrganizationType_Name_LocalTypeFactory.h"
#include "Mp7JrsOrganizationType_NameTerm_CollectionTypeFactory.h"
#include "Mp7JrsOrganizationType_NameTerm_LocalTypeFactory.h"
#include "Mp7JrsPackageTypeFactory.h"
#include "Mp7JrsPackageType_CollectionTypeFactory.h"
#include "Mp7JrsPackageType_LocalTypeFactory.h"
#include "Mp7JrsPackageType_Scheme_LocalTypeFactory.h"
#include "Mp7JrspaddingTypeFactory.h"
#include "Mp7JrspaddingType_LocalType0Factory.h"
#include "Mp7JrspaddingType_LocalType1Factory.h"
#include "Mp7JrspaddingType_LocalType2Factory.h"
#include "Mp7JrsParameterTrajectoryTypeFactory.h"
#include "Mp7JrsParametricMotionTypeFactory.h"
#include "Mp7JrsParametricMotionType_CoordDef_LocalTypeFactory.h"
#include "Mp7JrsParametricMotionType_CoordRef_LocalTypeFactory.h"
#include "Mp7JrsParametricMotionType_Parameters_LocalTypeFactory.h"
#include "Mp7JrsParentalGuidanceTypeFactory.h"
#include "Mp7JrsParentalGuidanceType_Region_CollectionTypeFactory.h"
#include "Mp7JrsPartitionTypeFactory.h"
#include "Mp7JrsPartitionType_dim_LocalTypeFactory.h"
#include "Mp7JrsPercussiveInstrumentTimbreTypeFactory.h"
#include "Mp7JrsPersonGroupTypeFactory.h"
#include "Mp7JrsPersonGroupType_CollectionTypeFactory.h"
#include "Mp7JrsPersonGroupType_LocalTypeFactory.h"
#include "Mp7JrsPersonGroupType_Name_CollectionTypeFactory.h"
#include "Mp7JrsPersonGroupType_Name_LocalTypeFactory.h"
#include "Mp7JrsPersonGroupType_NameTerm_CollectionTypeFactory.h"
#include "Mp7JrsPersonGroupType_NameTerm_LocalTypeFactory.h"
#include "Mp7JrsPersonNameTypeFactory.h"
#include "Mp7JrsPersonNameType_CollectionTypeFactory.h"
#include "Mp7JrsPersonNameType_LocalTypeFactory.h"
#include "Mp7JrsPersonTypeFactory.h"
#include "Mp7JrsPersonType_Affiliation_CollectionTypeFactory.h"
#include "Mp7JrsPersonType_Affiliation_LocalTypeFactory.h"
#include "Mp7JrsPersonType_Citizenship_CollectionTypeFactory.h"
#include "Mp7JrsPersonType_CollectionTypeFactory.h"
#include "Mp7JrsPersonType_ElectronicAddress_CollectionTypeFactory.h"
#include "Mp7JrsPersonType_LocalTypeFactory.h"
#include "Mp7JrsPhoneLexiconIndexTypeFactory.h"
#include "Mp7JrsPhoneLexiconTypeFactory.h"
#include "Mp7JrsPhoneLexiconType_Token_CollectionTypeFactory.h"
#include "Mp7JrsPhoneticTranscriptionLexiconTypeFactory.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_CollectionTypeFactory.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_LocalTypeFactory.h"
#include "Mp7JrsPhoneticTranscriptionLexiconType_Token_phoneticTranscription_CollectionTypeFactory.h"
#include "Mp7JrsPhoneTypeFactory.h"
#include "Mp7JrsPlaceTypeFactory.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_CollectionTypeFactory.h"
#include "Mp7JrsPlaceType_AdministrativeUnit_LocalTypeFactory.h"
#include "Mp7JrsPlaceType_AstronomicalBody_CollectionTypeFactory.h"
#include "Mp7JrsPlaceType_GeographicPosition_LocalTypeFactory.h"
#include "Mp7JrsPlaceType_Name_CollectionTypeFactory.h"
#include "Mp7JrsPlaceType_NameTerm_CollectionTypeFactory.h"
#include "Mp7JrsPlaceType_PostalAddress_AddressLine_CollectionTypeFactory.h"
#include "Mp7JrsPlaceType_PostalAddress_LocalTypeFactory.h"
#include "Mp7JrsPlaceType_Region_CollectionTypeFactory.h"
#include "Mp7JrsPointOfViewTypeFactory.h"
#include "Mp7JrsPointOfViewType_Importance_CollectionTypeFactory.h"
#include "Mp7JrsPointOfViewType_Importance_LocalTypeFactory.h"
#include "Mp7JrsPoissonDistributionTypeFactory.h"
#include "Mp7JrsPositionTypeFactory.h"
#include "Mp7JrsPreferenceConditionTypeFactory.h"
#include "Mp7JrsPreferenceConditionType_Time_CollectionTypeFactory.h"
#include "Mp7JrsPreferenceConditionType_Time_LocalTypeFactory.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType0Factory.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1Factory.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType2Factory.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType3Factory.h"
#include "Mp7JrspreferenceValueTypeFactory.h"
#include "Mp7JrsProbabilityClassificationModelTypeFactory.h"
#include "Mp7JrsProbabilityClassificationModelType_ProbabilityModelClass_CollectionTypeFactory.h"
#include "Mp7JrsProbabilityDistributionTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_CollectionTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_LocalTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Cumulant_Value_LocalTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Moment_CollectionTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Moment_LocalTypeFactory.h"
#include "Mp7JrsProbabilityDistributionType_Moment_Value_LocalTypeFactory.h"
#include "Mp7JrsProbabilityMatrixTypeFactory.h"
#include "Mp7JrsProbabilityModelClassTypeFactory.h"
#include "Mp7JrsProbabilityModelClassType_CollectionTypeFactory.h"
#include "Mp7JrsProbabilityModelClassType_LocalTypeFactory.h"
#include "Mp7JrsProbabilityModelTypeFactory.h"
#include "Mp7JrsprobabilityVectorFactory.h"
#include "Mp7JrsprobabilityVector_LocalTypeFactory.h"
#include "Mp7JrsPullbackDefinitionTypeFactory.h"
#include "Mp7JrsPushoutDefinitionTypeFactory.h"
#include "Mp7JrsRatingTypeFactory.h"
#include "Mp7JrsRatingType_RatingScheme_LocalTypeFactory.h"
#include "Mp7JrsReferenceTypeFactory.h"
#include "Mp7JrsregionCodeFactory.h"
#include "Mp7JrsRegionLocatorTypeFactory.h"
#include "Mp7JrsRegionLocatorType_Box_CollectionTypeFactory.h"
#include "Mp7JrsRegionLocatorType_Box_LocalTypeFactory.h"
#include "Mp7JrsRegionLocatorType_CoordRef_LocalTypeFactory.h"
#include "Mp7JrsRegionLocatorType_Polygon_CollectionTypeFactory.h"
#include "Mp7JrsRegionLocatorType_Polygon_LocalTypeFactory.h"
#include "Mp7JrsRegionShapeTypeFactory.h"
#include "Mp7JrsRegionShapeType_MagnitudeOfART_CollectionTypeFactory.h"
#include "Mp7JrsRegionShapeType_MagnitudeOfART_LocalTypeFactory.h"
#include "Mp7JrsRegularVisualTimeSeriesTypeFactory.h"
#include "Mp7JrsRegularVisualTimeSeriesType_Descriptor_CollectionTypeFactory.h"
#include "Mp7JrsRelatedMaterialTypeFactory.h"
#include "Mp7JrsRelationTypeFactory.h"
#include "Mp7JrsRelationType_source_CollectionTypeFactory.h"
#include "Mp7JrsRelationType_target_CollectionTypeFactory.h"
#include "Mp7JrsRelativeDelayTypeFactory.h"
#include "Mp7JrsRelIncrTimePointTypeFactory.h"
#include "Mp7JrsRelTimePointTypeFactory.h"
#include "Mp7JrsResolutionViewTypeFactory.h"
#include "Mp7JrsRightsTypeFactory.h"
#include "Mp7JrsRightsType_RightsID_CollectionTypeFactory.h"
#include "Mp7JrsScalableColorTypeFactory.h"
#include "Mp7JrsScalableSeriesTypeFactory.h"
#include "Mp7JrsScalableSeriesType_Scaling_CollectionTypeFactory.h"
#include "Mp7JrsScalableSeriesType_Scaling_LocalTypeFactory.h"
#include "Mp7JrsscaleTypeFactory.h"
#include "Mp7JrsSceneGraphMaskTypeFactory.h"
#include "Mp7JrsSceneGraphMaskType_CollectionTypeFactory.h"
#include "Mp7JrsSceneGraphMaskType_LocalTypeFactory.h"
#include "Mp7JrsSegmentCollectionTypeFactory.h"
#include "Mp7JrsSegmentCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsSegmentCollectionType_CollectionType0Factory.h"
#include "Mp7JrsSegmentCollectionType_LocalTypeFactory.h"
#include "Mp7JrsSegmentCollectionType_LocalType0Factory.h"
#include "Mp7JrsSegmentDecompositionTypeFactory.h"
#include "Mp7JrsSegmentTypeFactory.h"
#include "Mp7JrsSegmentType_CollectionTypeFactory.h"
#include "Mp7JrsSegmentType_LocalTypeFactory.h"
#include "Mp7JrsSegmentType_MatchingHint_CollectionTypeFactory.h"
#include "Mp7JrsSegmentType_PointOfView_CollectionTypeFactory.h"
#include "Mp7JrsSegmentType_Relation_CollectionTypeFactory.h"
#include "Mp7JrsSegmentType_TextAnnotation_CollectionTypeFactory.h"
#include "Mp7JrsSegmentType_TextAnnotation_LocalTypeFactory.h"
#include "Mp7JrsSegmentType_TextAnnotation_type_LocalTypeFactory.h"
#include "Mp7JrsSemanticBagTypeFactory.h"
#include "Mp7JrsSemanticBagType_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBagType_Graph_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBagType_LocalTypeFactory.h"
#include "Mp7JrsSemanticBaseTypeFactory.h"
#include "Mp7JrsSemanticBaseType_Label_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_LocalTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType0Factory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType1Factory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2Factory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType3Factory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_Property_CollectionTypeFactory.h"
#include "Mp7JrsSemanticBaseType_Relation_CollectionTypeFactory.h"
#include "Mp7JrsSemanticDescriptionTypeFactory.h"
#include "Mp7JrsSemanticDescriptionType_ConceptCollection_CollectionTypeFactory.h"
#include "Mp7JrsSemanticDescriptionType_Semantics_CollectionTypeFactory.h"
#include "Mp7JrsSemanticPlaceTypeFactory.h"
#include "Mp7JrsSemanticPlaceType_SemanticPlaceInterval_CollectionTypeFactory.h"
#include "Mp7JrsSemanticPlaceType_SemanticPlaceInterval_LocalTypeFactory.h"
#include "Mp7JrsSemanticStateTypeFactory.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_CollectionTypeFactory.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_CollectionType0Factory.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalTypeFactory.h"
#include "Mp7JrsSemanticStateType_AttributeValuePair_LocalType0Factory.h"
#include "Mp7JrsSemanticTimeTypeFactory.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_CollectionTypeFactory.h"
#include "Mp7JrsSemanticTimeType_SemanticTimeInterval_LocalTypeFactory.h"
#include "Mp7JrsSemanticTypeFactory.h"
#include "Mp7JrsSentencesTypeFactory.h"
#include "Mp7JrsSentencesType_CollectionTypeFactory.h"
#include "Mp7JrsSentencesType_LocalTypeFactory.h"
#include "Mp7JrsSequentialSummaryTypeFactory.h"
#include "Mp7JrsSequentialSummaryType_AudioSummaryComponent_CollectionTypeFactory.h"
#include "Mp7JrsSequentialSummaryType_components_CollectionTypeFactory.h"
#include "Mp7JrsSequentialSummaryType_TextualSummaryComponent_CollectionTypeFactory.h"
#include "Mp7JrsSequentialSummaryType_VisualSummaryComponent_CollectionTypeFactory.h"
#include "Mp7JrsSeriesOfScalarBinaryTypeFactory.h"
#include "Mp7JrsSeriesOfScalarTypeFactory.h"
#include "Mp7JrsSeriesOfVectorBinaryTypeFactory.h"
#include "Mp7JrsSeriesOfVectorTypeFactory.h"
#include "Mp7JrsShape3DTypeFactory.h"
#include "Mp7JrsShape3DType_Spectrum_CollectionTypeFactory.h"
#include "Mp7JrsShape3DType_Spectrum_LocalTypeFactory.h"
#include "Mp7JrsShapeVariationTypeFactory.h"
#include "Mp7JrsShapeVariationType_DynamicShapeVariation_CollectionTypeFactory.h"
#include "Mp7JrsShapeVariationType_DynamicShapeVariation_LocalTypeFactory.h"
#include "Mp7JrsShapeVariationType_StaticShapeVariation_CollectionTypeFactory.h"
#include "Mp7JrsShapeVariationType_StaticShapeVariation_LocalTypeFactory.h"
#include "Mp7JrsShapeVariationType_StatisticalVariation_CollectionTypeFactory.h"
#include "Mp7JrsShapeVariationType_StatisticalVariation_LocalTypeFactory.h"
#include "Mp7JrsShotEditingTemporalDecompositionTypeFactory.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsShotTypeFactory.h"
#include "Mp7JrsShotType_AnalyticEditingTemporalDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsSignalPlaneFractionTypeFactory.h"
#include "Mp7JrsSignalPlaneOriginTypeFactory.h"
#include "Mp7JrsSignalPlaneSampleTypeFactory.h"
#include "Mp7JrsSignalPlaneTypeFactory.h"
#include "Mp7JrsSignalPlaneType_dim_LocalTypeFactory.h"
#include "Mp7JrsSignalTypeFactory.h"
#include "Mp7JrsSilenceHeaderTypeFactory.h"
#include "Mp7JrsSilenceTypeFactory.h"
#include "Mp7JrsSoundClassificationModelTypeFactory.h"
#include "Mp7JrsSoundClassificationModelType_SoundModel_CollectionTypeFactory.h"
#include "Mp7JrsSoundModelStateHistogramTypeFactory.h"
#include "Mp7JrsSoundModelStateHistogramType_CollectionTypeFactory.h"
#include "Mp7JrsSoundModelStateHistogramType_LocalTypeFactory.h"
#include "Mp7JrsSoundModelStatePathTypeFactory.h"
#include "Mp7JrsSoundModelTypeFactory.h"
#include "Mp7JrsSourcePreferencesTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationDate_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationDate_LocalTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationFormat_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationFormat_LocalTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationLocation_LocalTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationSource_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_DisseminationSource_LocalTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_Disseminator_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_Disseminator_LocalTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_CollectionTypeFactory.h"
#include "Mp7JrsSourcePreferencesType_MediaFormat_LocalTypeFactory.h"
#include "Mp7JrsSpaceFrequencyGraphTypeFactory.h"
#include "Mp7JrsSpaceFrequencyGraphType_CollectionTypeFactory.h"
#include "Mp7JrsSpaceFrequencyGraphType_CollectionType0Factory.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalTypeFactory.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalType0Factory.h"
#include "Mp7JrsSpaceFrequencyViewTypeFactory.h"
#include "Mp7JrsSpaceResolutionViewTypeFactory.h"
#include "Mp7JrsSpaceTreeTypeFactory.h"
#include "Mp7JrsSpaceTreeType_CollectionTypeFactory.h"
#include "Mp7JrsSpaceTreeType_LocalTypeFactory.h"
#include "Mp7JrsSpaceViewTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_CollectionTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType0Factory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0Factory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0Factory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Factory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalTypeFactory.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalTypeFactory.h"
#include "Mp7JrsSpatialMaskTypeFactory.h"
#include "Mp7JrsSpatialMaskType_SubRegion_CollectionTypeFactory.h"
#include "Mp7JrsSpatialSegmentDecompositionTypeFactory.h"
#include "Mp7JrsSpatioTemporalLocatorTypeFactory.h"
#include "Mp7JrsSpatioTemporalLocatorType_CollectionTypeFactory.h"
#include "Mp7JrsSpatioTemporalLocatorType_CoordRef_LocalTypeFactory.h"
#include "Mp7JrsSpatioTemporalLocatorType_LocalTypeFactory.h"
#include "Mp7JrsSpatioTemporalMaskTypeFactory.h"
#include "Mp7JrsSpatioTemporalMaskType_SubRegion_CollectionTypeFactory.h"
#include "Mp7JrsSpatioTemporalSegmentDecompositionTypeFactory.h"
#include "Mp7JrsSpeakerInfoTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_LocalTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_IndexEntry_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_key_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_PhoneIndex_PhoneIndexEntry_LocalTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_LocalTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_IndexEntry_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_key_CollectionTypeFactory.h"
#include "Mp7JrsSpeakerInfoType_WordIndex_WordIndexEntry_LocalTypeFactory.h"
#include "Mp7JrsSpectralCentroidTypeFactory.h"
#include "Mp7JrsSpokenContentHeaderTypeFactory.h"
#include "Mp7JrsSpokenContentHeaderType_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentHeaderType_ConfusionInfo_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentHeaderType_LocalTypeFactory.h"
#include "Mp7JrsSpokenContentHeaderType_SpeakerInfo_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentIndexEntryTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_LocalTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_LocalTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_PhoneLink_LocalTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_CollectionTypeFactory.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_WordLink_LocalTypeFactory.h"
#include "Mp7JrsSpokenContentLinkTypeFactory.h"
#include "Mp7JrsStateTransitionModelTypeFactory.h"
#include "Mp7JrsStateTransitionModelType_State_CollectionTypeFactory.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionTypeFactory.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsStillRegion3DSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsStillRegion3DTypeFactory.h"
#include "Mp7JrsStillRegion3DType_CollectionTypeFactory.h"
#include "Mp7JrsStillRegion3DType_LocalTypeFactory.h"
#include "Mp7JrsStillRegion3DType_SpatialDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsStillRegionFeatureTypeFactory.h"
#include "Mp7JrsStillRegionSpatialDecompositionTypeFactory.h"
#include "Mp7JrsStillRegionSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsStillRegionSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsStillRegionTypeFactory.h"
#include "Mp7JrsStillRegionType_CollectionTypeFactory.h"
#include "Mp7JrsStillRegionType_LocalTypeFactory.h"
#include "Mp7JrsStillRegionType_SpatialDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsStreamLocatorTypeFactory.h"
#include "Mp7JrsStreamMaskTypeFactory.h"
#include "Mp7JrsStreamMaskType_StreamSection_CollectionTypeFactory.h"
#include "Mp7JrsStreamSectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_How_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_WhatAction_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_WhatObject_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_When_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_Where_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_Who_CollectionTypeFactory.h"
#include "Mp7JrsStructuredAnnotationType_Why_CollectionTypeFactory.h"
#include "Mp7JrsStructuredCollectionTypeFactory.h"
#include "Mp7JrsStructuredCollectionType_CollectionTypeFactory.h"
#include "Mp7JrsStructuredCollectionType_CollectionType0Factory.h"
#include "Mp7JrsStructuredCollectionType_CollectionType1Factory.h"
#include "Mp7JrsStructuredCollectionType_CollectionType2Factory.h"
#include "Mp7JrsStructuredCollectionType_LocalTypeFactory.h"
#include "Mp7JrsStructuredCollectionType_LocalType0Factory.h"
#include "Mp7JrsStructuredCollectionType_LocalType1Factory.h"
#include "Mp7JrsStructuredCollectionType_LocalType2Factory.h"
#include "Mp7JrsStructuredCollectionType_Relationships_CollectionTypeFactory.h"
#include "Mp7JrsSubjectClassificationSchemeTypeFactory.h"
#include "Mp7JrsSubjectClassificationSchemeType_Term_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Classification_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_LocalTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Note_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Note_LocalTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_CollectionTypeFactory.h"
#include "Mp7JrsSubjectTermDefinitionType_Term_LocalTypeFactory.h"
#include "Mp7JrsSummarizationTypeFactory.h"
#include "Mp7JrsSummarizationType_Summary_CollectionTypeFactory.h"
#include "Mp7JrssummaryComponentTypeFactory.h"
#include "Mp7JrssummaryComponentType_LocalType0Factory.h"
#include "Mp7JrssummaryComponentType_LocalType1Factory.h"
#include "Mp7JrssummaryComponentType_LocalType2Factory.h"
#include "Mp7JrsSummaryDescriptionTypeFactory.h"
#include "Mp7JrsSummaryDescriptionType_Summarization_CollectionTypeFactory.h"
#include "Mp7JrsSummaryPreferencesTypeFactory.h"
#include "Mp7JrsSummaryPreferencesType_SummaryTheme_CollectionTypeFactory.h"
#include "Mp7JrsSummaryPreferencesType_SummaryTheme_LocalTypeFactory.h"
#include "Mp7JrsSummaryPreferencesType_SummaryType_CollectionTypeFactory.h"
#include "Mp7JrsSummaryPreferencesType_SummaryType_LocalTypeFactory.h"
#include "Mp7JrsSummarySegmentGroupTypeFactory.h"
#include "Mp7JrsSummarySegmentGroupType_Caption_CollectionTypeFactory.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionTypeFactory.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionType0Factory.h"
#include "Mp7JrsSummarySegmentGroupType_LocalTypeFactory.h"
#include "Mp7JrsSummarySegmentGroupType_LocalType0Factory.h"
#include "Mp7JrsSummarySegmentGroupType_Name_CollectionTypeFactory.h"
#include "Mp7JrsSummarySegmentTypeFactory.h"
#include "Mp7JrsSummarySegmentType_KeyFrame_CollectionTypeFactory.h"
#include "Mp7JrsSummarySegmentType_KeySound_CollectionTypeFactory.h"
#include "Mp7JrsSummarySegmentType_Name_CollectionTypeFactory.h"
#include "Mp7JrsSummaryThemeListTypeFactory.h"
#include "Mp7JrsSummaryThemeListType_SummaryTheme_CollectionTypeFactory.h"
#include "Mp7JrsSummaryThemeListType_SummaryTheme_LocalTypeFactory.h"
#include "Mp7JrsSummaryTypeFactory.h"
#include "Mp7JrsSummaryType_Name_CollectionTypeFactory.h"
#include "Mp7JrsSyntacticConstituentTypeFactory.h"
#include "Mp7JrsSyntacticConstituentType_CollectionTypeFactory.h"
#include "Mp7JrsSyntacticConstituentType_LocalTypeFactory.h"
#include "Mp7JrsTemporalCentroidTypeFactory.h"
#include "Mp7JrsTemporalInterpolationTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_CollectionTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_CollectionTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_LocalTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_LocalTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelIncrTimePoint_CollectionTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaRelTimePoint_CollectionTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_KeyTimePoint_MediaTimePoint_CollectionTypeFactory.h"
#include "Mp7JrsTemporalInterpolationType_WholeInterval_LocalTypeFactory.h"
#include "Mp7JrsTemporalMaskTypeFactory.h"
#include "Mp7JrsTemporalMaskType_SubInterval_CollectionTypeFactory.h"
#include "Mp7JrsTemporalSegmentDecompositionTypeFactory.h"
#include "Mp7JrsTemporalSegmentLocatorTypeFactory.h"
#include "Mp7JrsTemporalSegmentLocatorType_BytePosition_LocalTypeFactory.h"
#include "Mp7JrsTermDefinitionBaseTypeFactory.h"
#include "Mp7JrsTermDefinitionBaseType_Definition_CollectionTypeFactory.h"
#include "Mp7JrsTermDefinitionBaseType_Name_CollectionTypeFactory.h"
#include "Mp7JrsTermDefinitionBaseType_Name_LocalTypeFactory.h"
#include "Mp7JrsTermDefinitionTypeFactory.h"
#include "Mp7JrsTermDefinitionType_Term_CollectionTypeFactory.h"
#include "Mp7JrsTermDefinitionType_Term_LocalTypeFactory.h"
#include "Mp7JrstermNoteQualifierTypeFactory.h"
#include "Mp7JrstermNoteQualifierType_LocalType0Factory.h"
#include "Mp7JrstermNoteQualifierType_LocalType1Factory.h"
#include "Mp7JrstermNoteQualifierType_LocalType2Factory.h"
#include "Mp7JrstermReferenceListTypeFactory.h"
#include "Mp7JrstermReferenceTypeFactory.h"
#include "Mp7JrstermReferenceType_LocalTypeFactory.h"
#include "Mp7JrstermReferenceType_LocalType0Factory.h"
#include "Mp7JrstermRelationQualifierTypeFactory.h"
#include "Mp7JrstermRelationQualifierType_LocalType0Factory.h"
#include "Mp7JrstermRelationQualifierType_LocalType1Factory.h"
#include "Mp7JrstermRelationQualifierType_LocalType2Factory.h"
#include "Mp7JrsTermUseTypeFactory.h"
#include "Mp7JrsTextAnnotationTypeFactory.h"
#include "Mp7JrsTextAnnotationType_CollectionTypeFactory.h"
#include "Mp7JrsTextAnnotationType_LocalTypeFactory.h"
#include "Mp7JrsTextDecompositionTypeFactory.h"
#include "Mp7JrsTextDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsTextDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsTextSegmentTypeFactory.h"
#include "Mp7JrsTextSegmentType_TextDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsTextTypeFactory.h"
#include "Mp7JrsTextualBaseTypeFactory.h"
#include "Mp7JrsTextualBaseType_phoneticTranscription_CollectionTypeFactory.h"
#include "Mp7JrsTextualSummaryComponentTypeFactory.h"
#include "Mp7JrsTextualSummaryComponentType_FreeText_CollectionTypeFactory.h"
#include "Mp7JrsTextualTypeFactory.h"
#include "Mp7JrsTextureBrowsingTypeFactory.h"
#include "Mp7JrsTextureBrowsingType_CollectionTypeFactory.h"
#include "Mp7JrsTextureBrowsingType_LocalTypeFactory.h"
#include "Mp7JrstextureListTypeFactory.h"
#include "Mp7JrstextureListType_CollectionTypeFactory.h"
#include "Mp7JrstimeOffsetTypeFactory.h"
#include "Mp7JrstimePointTypeFactory.h"
#include "Mp7JrsTimeTypeFactory.h"
#include "Mp7JrsTitleMediaTypeFactory.h"
#include "Mp7JrsTitleTypeFactory.h"
#include "Mp7JrsTitleType_type_LocalType0Factory.h"
#include "Mp7JrsTitleType_type_LocalType1Factory.h"
#include "Mp7JrsTitleType_type_LocalType2Factory.h"
#include "Mp7JrsTitleType_type_LocalType3Factory.h"
#include "Mp7JrsTransmissionTechnologyTypeFactory.h"
#include "Mp7JrsUniqueIDTypeFactory.h"
#include "Mp7Jrsunsigned1Factory.h"
#include "Mp7Jrsunsigned10Factory.h"
#include "Mp7Jrsunsigned11Factory.h"
#include "Mp7Jrsunsigned12Factory.h"
#include "Mp7Jrsunsigned13Factory.h"
#include "Mp7Jrsunsigned14Factory.h"
#include "Mp7Jrsunsigned15Factory.h"
#include "Mp7Jrsunsigned16Factory.h"
#include "Mp7Jrsunsigned17Factory.h"
#include "Mp7Jrsunsigned18Factory.h"
#include "Mp7Jrsunsigned19Factory.h"
#include "Mp7Jrsunsigned2Factory.h"
#include "Mp7Jrsunsigned20Factory.h"
#include "Mp7Jrsunsigned21Factory.h"
#include "Mp7Jrsunsigned22Factory.h"
#include "Mp7Jrsunsigned23Factory.h"
#include "Mp7Jrsunsigned24Factory.h"
#include "Mp7Jrsunsigned25Factory.h"
#include "Mp7Jrsunsigned26Factory.h"
#include "Mp7Jrsunsigned27Factory.h"
#include "Mp7Jrsunsigned28Factory.h"
#include "Mp7Jrsunsigned29Factory.h"
#include "Mp7Jrsunsigned3Factory.h"
#include "Mp7Jrsunsigned30Factory.h"
#include "Mp7Jrsunsigned31Factory.h"
#include "Mp7Jrsunsigned32Factory.h"
#include "Mp7Jrsunsigned4Factory.h"
#include "Mp7Jrsunsigned5Factory.h"
#include "Mp7Jrsunsigned6Factory.h"
#include "Mp7Jrsunsigned7Factory.h"
#include "Mp7Jrsunsigned8Factory.h"
#include "Mp7Jrsunsigned9Factory.h"
#include "Mp7JrsUsageDescriptionTypeFactory.h"
#include "Mp7JrsUsageDescriptionType_UsageInformation_CollectionTypeFactory.h"
#include "Mp7JrsUsageHistoryTypeFactory.h"
#include "Mp7JrsUsageHistoryType_UserActionHistory_CollectionTypeFactory.h"
#include "Mp7JrsUsageInformationTypeFactory.h"
#include "Mp7JrsUsageInformationType_Availability_CollectionTypeFactory.h"
#include "Mp7JrsUsageInformationType_UsageRecord_CollectionTypeFactory.h"
#include "Mp7JrsUsageRecordTypeFactory.h"
#include "Mp7JrsUserActionHistoryTypeFactory.h"
#include "Mp7JrsUserActionHistoryType_ObservationPeriod_CollectionTypeFactory.h"
#include "Mp7JrsUserActionHistoryType_UserActionList_CollectionTypeFactory.h"
#include "Mp7JrsUserActionListTypeFactory.h"
#include "Mp7JrsUserActionListType_UserAction_CollectionTypeFactory.h"
#include "Mp7JrsUserActionTypeFactory.h"
#include "Mp7JrsUserActionType_ActionDataItem_CollectionTypeFactory.h"
#include "Mp7JrsUserActionType_ActionTime_LocalTypeFactory.h"
#include "Mp7JrsUserDescriptionTypeFactory.h"
#include "Mp7JrsUserDescriptionType_UsageHistory_CollectionTypeFactory.h"
#include "Mp7JrsUserDescriptionType_UserPreferences_CollectionTypeFactory.h"
#include "Mp7JrsUserIdentifierTypeFactory.h"
#include "Mp7JrsUserPreferencesTypeFactory.h"
#include "Mp7JrsUserPreferencesType_BrowsingPreferences_CollectionTypeFactory.h"
#include "Mp7JrsUserPreferencesType_FilteringAndSearchPreferences_CollectionTypeFactory.h"
#include "Mp7JrsVariationDescriptionTypeFactory.h"
#include "Mp7JrsVariationDescriptionType_Variation_CollectionTypeFactory.h"
#include "Mp7JrsVariationDescriptionType_VariationSet_CollectionTypeFactory.h"
#include "Mp7JrsVariationSetTypeFactory.h"
#include "Mp7JrsVariationSetType_Variation_CollectionTypeFactory.h"
#include "Mp7JrsVariationTypeFactory.h"
#include "Mp7JrsVariationType_VariationRelationship_CollectionTypeFactory.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType0Factory.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType1Factory.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType2Factory.h"
#include "Mp7JrsVariationType_VariationRelationship_LocalType3Factory.h"
#include "Mp7JrsVideoSegmentFeatureTypeFactory.h"
#include "Mp7JrsVideoSegmentFeatureType_RepresentativeFeature_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentFeatureType_TemporalTransition_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionTypeFactory.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentMediaSourceDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionTypeFactory.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionType_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsVideoSegmentTypeFactory.h"
#include "Mp7JrsVideoSegmentType_CollectionTypeFactory.h"
#include "Mp7JrsVideoSegmentType_CollectionType0Factory.h"
#include "Mp7JrsVideoSegmentType_LocalTypeFactory.h"
#include "Mp7JrsVideoSegmentType_LocalType0Factory.h"
#include "Mp7JrsVideoSegmentType_Mosaic_CollectionTypeFactory.h"
#include "Mp7JrsVideoTextTypeFactory.h"
#include "Mp7JrsVideoTextType_textType_LocalType0Factory.h"
#include "Mp7JrsVideoTextType_textType_LocalType1Factory.h"
#include "Mp7JrsVideoTextType_textType_LocalType2Factory.h"
#include "Mp7JrsVideoTextType_textType_LocalType3Factory.h"
#include "Mp7JrsVideoTypeFactory.h"
#include "Mp7JrsVideoViewGraphTypeFactory.h"
#include "Mp7JrsVideoViewGraphType_CollectionTypeFactory.h"
#include "Mp7JrsVideoViewGraphType_CollectionType0Factory.h"
#include "Mp7JrsVideoViewGraphType_LocalTypeFactory.h"
#include "Mp7JrsVideoViewGraphType_LocalType0Factory.h"
#include "Mp7JrsViewDecompositionTypeFactory.h"
#include "Mp7JrsViewDescriptionTypeFactory.h"
#include "Mp7JrsViewDescriptionType_View_CollectionTypeFactory.h"
#include "Mp7JrsViewDescriptionType_ViewDecomposition_CollectionTypeFactory.h"
#include "Mp7JrsViewDescriptionType_ViewSet_CollectionTypeFactory.h"
#include "Mp7JrsViewSetTypeFactory.h"
#include "Mp7JrsViewSetType_CollectionTypeFactory.h"
#include "Mp7JrsViewSetType_LocalTypeFactory.h"
#include "Mp7JrsViewSetType_setProperty_LocalType0Factory.h"
#include "Mp7JrsViewSetType_setProperty_LocalType1Factory.h"
#include "Mp7JrsViewSetType_setProperty_LocalType2Factory.h"
#include "Mp7JrsViewSetType_setProperty_LocalType3Factory.h"
#include "Mp7JrsViewTypeFactory.h"
#include "Mp7JrsVisualDSTypeFactory.h"
#include "Mp7JrsVisualDTypeFactory.h"
#include "Mp7JrsVisualSummaryComponentTypeFactory.h"
#include "Mp7JrsVisualTimeSeriesTypeFactory.h"
#include "Mp7JrsWordFormTypeFactory.h"
#include "Mp7JrsWordFormType_terms_CollectionTypeFactory.h"
#include "Mp7JrsWordFormType_type_CollectionTypeFactory.h"
#include "Mp7JrsWordFormType_type_LocalType0Factory.h"
#include "Mp7JrsWordFormType_type_LocalType1Factory.h"
#include "Mp7JrsWordFormType_type_LocalType2Factory.h"
#include "Mp7JrsWordFormType_type_LocalType3Factory.h"
#include "Mp7JrsWordLexiconIndexTypeFactory.h"
#include "Mp7JrsWordLexiconTypeFactory.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType0Factory.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType1Factory.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType2Factory.h"
#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType3Factory.h"
#include "Mp7JrsWordLexiconType_Token_LocalTypeFactory.h"
#include "Mp7JrsWordTypeFactory.h"
#include "Mp7JrsxPathAbsoluteSelectorTypeFactory.h"
#include "Mp7JrsxPathFieldTypeFactory.h"
#include "Mp7JrsxPathRefTypeFactory.h"
#include "Mp7JrsxPathSelectorTypeFactory.h"
#include "Mp7JrsxPathTypeFactory.h"
#include "Mp7JrszeroToOneTypeFactory.h"

