/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _951MP7JRSGENERALRELATIONTYPE_H
#define _951MP7JRSGENERALRELATIONTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGeneralRelationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsGeneralRelationType_ExtInclude.h


#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsRelationType.h"
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsGeneralRelationType;
class IMp7JrsmediaDurationType;
class IMp7JrsRelationType;
class IMp7JrsRelationType_source_CollectionType;
class IMp7JrsRelationType_target_CollectionType;
class IMp7JrstermReferenceListType;
class IMp7JrstermReferenceType;
class IMp7JrsxPathRefType;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsGeneralRelationType> Mp7JrsGeneralRelationPtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsRelationType > Mp7JrsRelationPtr;
typedef Mp7JrsPtr< IMp7JrsRelationType_source_CollectionType > Mp7JrsRelationType_source_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsRelationType_target_CollectionType > Mp7JrsRelationType_target_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrstermReferenceListType > Mp7JrstermReferenceListPtr;
typedef Mp7JrsPtr< IMp7JrstermReferenceType > Mp7JrstermReferencePtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsGeneralRelationType for class Mp7JrsGeneralRelationType<br>
 * Located at: mpeg7-2004.xsd, line 9028<br>
 * Classified: Class<br>
 * Derived from: RelationType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsGeneralRelationType 
 :
        public IMp7JrsRelationType
{
public:
    // TODO: make these protected?
    IMp7JrsGeneralRelationType();
    virtual ~IMp7JrsGeneralRelationType();
    /**
     * Get typelist attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr Gettypelist() const = 0;

    /**
     * Get typelist attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtypelist() const = 0;

    /**
     * Set typelist attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void Settypelist(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate typelist attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetypelist() = 0;

    /**
     * Get generalSource attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr GetgeneralSource() const = 0;

    /**
     * Get generalSource attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistgeneralSource() const = 0;

    /**
     * Set generalSource attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void SetgeneralSource(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate generalSource attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidategeneralSource() = 0;

    /**
     * Get generalTarget attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr GetgeneralTarget() const = 0;

    /**
     * Get generalTarget attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistgeneralTarget() const = 0;

    /**
     * Set generalTarget attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void SetgeneralTarget(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate generalTarget attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidategeneralTarget() = 0;

    /**
     * Get type attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Settype(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

    /**
     * Get source attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrsRelationType_source_CollectionPtr
     */
    virtual Mp7JrsRelationType_source_CollectionPtr Getsource() const = 0;

    /**
     * Get source attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsource() const = 0;

    /**
     * Set source attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrsRelationType_source_CollectionPtr &
     */
    virtual void Setsource(const Mp7JrsRelationType_source_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate source attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesource() = 0;

    /**
     * Get target attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrsRelationType_target_CollectionPtr
     */
    virtual Mp7JrsRelationType_target_CollectionPtr Gettarget() const = 0;

    /**
     * Get target attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtarget() const = 0;

    /**
     * Set target attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrsRelationType_target_CollectionPtr &
     */
    virtual void Settarget(const Mp7JrsRelationType_target_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate target attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetarget() = 0;

    /**
     * Get directed attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return bool
     */
    virtual bool Getdirected() const = 0;

    /**
     * Get directed attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdirected() const = 0;

    /**
     * Set directed attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item bool
     */
    virtual void Setdirected(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate directed attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedirected() = 0;

    /**
     * Get strength attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getstrength() const = 0;

    /**
     * Get strength attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstrength() const = 0;

    /**
     * Set strength attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setstrength(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate strength attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestrength() = 0;

    /**
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const = 0;

    /**
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid() = 0;

    /**
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

    /**
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const = 0;

    /**
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase() = 0;

    /**
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

    /**
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const = 0;

    /**
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit() = 0;

    /**
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

    /**
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const = 0;

    /**
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase() = 0;

    /**
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

    /**
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const = 0;

    /**
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

    /**
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of GeneralRelationType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsGeneralRelationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGeneralRelationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGeneralRelationType<br>
 * Located at: mpeg7-2004.xsd, line 9028<br>
 * Classified: Class<br>
 * Derived from: RelationType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 9028.<br>
 */
class MP7JRS_EXPORT Mp7JrsGeneralRelationType :
        public IMp7JrsGeneralRelationType
{
    friend class Mp7JrsGeneralRelationTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsGeneralRelationType
     
     * @return Mp7JrsPtr< Mp7JrsRelationType >
     */
    virtual Mp7JrsPtr< Mp7JrsRelationType > GetBase() const;
    /*
     * Get typelist attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr Gettypelist() const;

    /*
     * Get typelist attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtypelist() const;

    /*
     * Set typelist attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void Settypelist(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate typelist attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetypelist();

    /*
     * Get generalSource attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr GetgeneralSource() const;

    /*
     * Get generalSource attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistgeneralSource() const;

    /*
     * Set generalSource attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void SetgeneralSource(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate generalSource attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidategeneralSource();

    /*
     * Get generalTarget attribute.
     * @return Mp7JrstermReferenceListPtr
     */
    virtual Mp7JrstermReferenceListPtr GetgeneralTarget() const;

    /*
     * Get generalTarget attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistgeneralTarget() const;

    /*
     * Set generalTarget attribute.
     * @param item const Mp7JrstermReferenceListPtr &
     */
    virtual void SetgeneralTarget(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate generalTarget attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidategeneralTarget();

    /*
     * Get type attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrstermReferencePtr
     */
    virtual Mp7JrstermReferencePtr Gettype() const;

    /*
     * Get type attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrstermReferencePtr &
     */
    virtual void Settype(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

    /*
     * Get source attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrsRelationType_source_CollectionPtr
     */
    virtual Mp7JrsRelationType_source_CollectionPtr Getsource() const;

    /*
     * Get source attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existsource() const;

    /*
     * Set source attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrsRelationType_source_CollectionPtr &
     */
    virtual void Setsource(const Mp7JrsRelationType_source_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate source attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatesource();

    /*
     * Get target attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrsRelationType_target_CollectionPtr
     */
    virtual Mp7JrsRelationType_target_CollectionPtr Gettarget() const;

    /*
     * Get target attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtarget() const;

    /*
     * Set target attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrsRelationType_target_CollectionPtr &
     */
    virtual void Settarget(const Mp7JrsRelationType_target_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate target attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetarget();

    /*
     * Get directed attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return bool
     */
    virtual bool Getdirected() const;

    /*
     * Get directed attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdirected() const;

    /*
     * Set directed attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item bool
     */
    virtual void Setdirected(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate directed attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedirected();

    /*
     * Get strength attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getstrength() const;

    /*
     * Get strength attribute validity information.
     * (Inherited from Mp7JrsRelationType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstrength() const;

    /*
     * Set strength attribute.
<br>
     * (Inherited from Mp7JrsRelationType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setstrength(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate strength attribute.
     * (Inherited from Mp7JrsRelationType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestrength();

    /*
     * Get id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Get id attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existid() const;

    /*
     * Set id attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item XMLCh *
     */
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate id attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateid();

    /*
     * Get timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GettimeBase() const;

    /*
     * Get timeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeBase() const;

    /*
     * Set timeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeBase();

    /*
     * Get timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsdurationPtr
     */
    virtual Mp7JrsdurationPtr GettimeUnit() const;

    /*
     * Get timeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExisttimeUnit() const;

    /*
     * Set timeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsdurationPtr &
     */
    virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate timeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatetimeUnit();

    /*
     * Get mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsxPathRefPtr
     */
    virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

    /*
     * Get mediaTimeBase attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeBase() const;

    /*
     * Set mediaTimeBase attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsxPathRefPtr &
     */
    virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeBase attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeBase();

    /*
     * Get mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsmediaDurationPtr
     */
    virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

    /*
     * Get mediaTimeUnit attribute validity information.
     * (Inherited from Mp7JrsDSType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistmediaTimeUnit() const;

    /*
     * Set mediaTimeUnit attribute.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsmediaDurationPtr &
     */
    virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate mediaTimeUnit attribute.
     * (Inherited from Mp7JrsDSType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatemediaTimeUnit();

        /* @name Sequence

         */
        //@{
    /*
     * Get Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @return Mp7JrsDSType_Header_CollectionPtr
     */
    virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

    /*
     * Set Header element.
<br>
     * (Inherited from Mp7JrsDSType)
     * @param item const Mp7JrsDSType_Header_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of GeneralRelationType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGeneralRelationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGeneralRelationType();

protected:
    Mp7JrsGeneralRelationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrstermReferenceListPtr m_typelist;
    bool m_typelist_Exist;
    Mp7JrstermReferenceListPtr m_generalSource;
    bool m_generalSource_Exist;
    Mp7JrstermReferenceListPtr m_generalTarget;
    bool m_generalTarget_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsRelationType > m_Base;


// no includefile for extension defined 
// file Mp7JrsGeneralRelationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _951MP7JRSGENERALRELATIONTYPE_H

