/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1161MP7JRSIRREGULARVISUALTIMESERIESTYPE_LOCALTYPE_H
#define _1161MP7JRSIRREGULARVISUALTIMESERIESTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_LocalType_ExtInclude.h


class IMp7JrsIrregularVisualTimeSeriesType_LocalType;
class IMp7Jrsunsigned32;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsIrregularVisualTimeSeriesType_LocalType> Mp7JrsIrregularVisualTimeSeriesType_LocalPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned32 > Mp7Jrsunsigned32Ptr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsIrregularVisualTimeSeriesType_LocalType for class Mp7JrsIrregularVisualTimeSeriesType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsIrregularVisualTimeSeriesType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsIrregularVisualTimeSeriesType_LocalType();
    virtual ~IMp7JrsIrregularVisualTimeSeriesType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Descriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetDescriptor() const = 0;

    /**
     * Set Descriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    // Mandatory abstract element, possible types are
    // Mp7JrsAdvancedFaceRecognitionPtr
    // Mp7JrsCameraMotionPtr
    // Mp7JrsColorLayoutPtr
    // Mp7JrsColorStructurePtr
    // Mp7JrsColorTemperaturePtr
    // Mp7JrsContourShapePtr
    // Mp7JrsDominantColorPtr
    // Mp7JrsEdgeHistogramPtr
    // Mp7JrsFaceRecognitionPtr
    // Mp7JrsGoFGoPColorPtr
    // Mp7JrsHomogeneousTexturePtr
    // Mp7JrsMotionActivityPtr
    // Mp7JrsMotionTrajectoryPtr
    // Mp7JrsParametricMotionPtr
    // Mp7JrsRegionShapePtr
    // Mp7JrsScalableColorPtr
    // Mp7JrsShape3DPtr
    // Mp7JrsShapeVariationPtr
    // Mp7JrsTextureBrowsingPtr
    virtual void SetDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Interval element.
     * @return Mp7Jrsunsigned32Ptr
     */
    virtual Mp7Jrsunsigned32Ptr GetInterval() const = 0;

    /**
     * Set Interval element.
     * @param item const Mp7Jrsunsigned32Ptr &
     */
    // Mandatory			
    virtual void SetInterval(const Mp7Jrsunsigned32Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsIrregularVisualTimeSeriesType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 129.<br>
 */
class MP7JRS_EXPORT Mp7JrsIrregularVisualTimeSeriesType_LocalType :
        public IMp7JrsIrregularVisualTimeSeriesType_LocalType
{
    friend class Mp7JrsIrregularVisualTimeSeriesType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Descriptor element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetDescriptor() const;

    /*
     * Set Descriptor element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAdvancedFaceRecognitionPtr</li>
     * <li>IMp7JrsCameraMotionPtr</li>
     * <li>IMp7JrsColorLayoutPtr</li>
     * <li>IMp7JrsColorStructurePtr</li>
     * <li>IMp7JrsColorTemperaturePtr</li>
     * <li>IMp7JrsContourShapePtr</li>
     * <li>IMp7JrsDominantColorPtr</li>
     * <li>IMp7JrsEdgeHistogramPtr</li>
     * <li>IMp7JrsFaceRecognitionPtr</li>
     * <li>IMp7JrsGoFGoPColorPtr</li>
     * <li>IMp7JrsHomogeneousTexturePtr</li>
     * <li>IMp7JrsMotionActivityPtr</li>
     * <li>IMp7JrsMotionTrajectoryPtr</li>
     * <li>IMp7JrsParametricMotionPtr</li>
     * <li>IMp7JrsRegionShapePtr</li>
     * <li>IMp7JrsScalableColorPtr</li>
     * <li>IMp7JrsShape3DPtr</li>
     * <li>IMp7JrsShapeVariationPtr</li>
     * <li>IMp7JrsTextureBrowsingPtr</li>
     * </ul>
     */
    // Mandatory abstract element, possible types are
    // Mp7JrsAdvancedFaceRecognitionPtr
    // Mp7JrsCameraMotionPtr
    // Mp7JrsColorLayoutPtr
    // Mp7JrsColorStructurePtr
    // Mp7JrsColorTemperaturePtr
    // Mp7JrsContourShapePtr
    // Mp7JrsDominantColorPtr
    // Mp7JrsEdgeHistogramPtr
    // Mp7JrsFaceRecognitionPtr
    // Mp7JrsGoFGoPColorPtr
    // Mp7JrsHomogeneousTexturePtr
    // Mp7JrsMotionActivityPtr
    // Mp7JrsMotionTrajectoryPtr
    // Mp7JrsParametricMotionPtr
    // Mp7JrsRegionShapePtr
    // Mp7JrsScalableColorPtr
    // Mp7JrsShape3DPtr
    // Mp7JrsShapeVariationPtr
    // Mp7JrsTextureBrowsingPtr
    virtual void SetDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Interval element.
     * @return Mp7Jrsunsigned32Ptr
     */
    virtual Mp7Jrsunsigned32Ptr GetInterval() const;

    /*
     * Set Interval element.
     * @param item const Mp7Jrsunsigned32Ptr &
     */
    // Mandatory			
    virtual void SetInterval(const Mp7Jrsunsigned32Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsIrregularVisualTimeSeriesType_LocalType();

protected:
    Mp7JrsIrregularVisualTimeSeriesType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsPtr< Mp7JrsNode > m_Descriptor;
    Mp7Jrsunsigned32Ptr m_Interval;

// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1161MP7JRSIRREGULARVISUALTIMESERIESTYPE_LOCALTYPE_H

