/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1339MP7JRSMEDIATRANSCODINGHINTSTYPE_SHAPEHINT_LOCALTYPE_H
#define _1339MP7JRSMEDIATRANSCODINGHINTSTYPE_SHAPEHINT_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtInclude.h


class IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType;
class IMp7JrsnonNegativeReal;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType> Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsnonNegativeReal > Mp7JrsnonNegativeRealPtr;

/** 
 * Generated interface IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType for class Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 4914<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType();
    virtual ~IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType();
    /**
     * Get shapeChange attribute.
     * @return float
     */
    virtual float GetshapeChange() const = 0;

    /**
     * Get shapeChange attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistshapeChange() const = 0;

    /**
     * Set shapeChange attribute.
     * @param item float
     */
    virtual void SetshapeChange(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate shapeChange attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateshapeChange() = 0;

    /**
     * Get numOfNonTranspBlocks attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetnumOfNonTranspBlocks() const = 0;

    /**
     * Get numOfNonTranspBlocks attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfNonTranspBlocks() const = 0;

    /**
     * Set numOfNonTranspBlocks attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetnumOfNonTranspBlocks(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate numOfNonTranspBlocks attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfNonTranspBlocks() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of MediaTranscodingHintsType_ShapeHint_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaTranscodingHintsType_ShapeHint_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 4914<br>
 * Classified: Class<br>
 * Defined in mpeg7-2004.xsd, line 4914.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType :
        public IMp7JrsMediaTranscodingHintsType_ShapeHint_LocalType
{
    friend class Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalTypeFactory; // constructs objects

public:
    /*
     * Get shapeChange attribute.
     * @return float
     */
    virtual float GetshapeChange() const;

    /*
     * Get shapeChange attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistshapeChange() const;

    /*
     * Set shapeChange attribute.
     * @param item float
     */
    virtual void SetshapeChange(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate shapeChange attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateshapeChange();

    /*
     * Get numOfNonTranspBlocks attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetnumOfNonTranspBlocks() const;

    /*
     * Get numOfNonTranspBlocks attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistnumOfNonTranspBlocks() const;

    /*
     * Set numOfNonTranspBlocks attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetnumOfNonTranspBlocks(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate numOfNonTranspBlocks attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatenumOfNonTranspBlocks();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of MediaTranscodingHintsType_ShapeHint_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaTranscodingHintsType_ShapeHint_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType();

protected:
    Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    float m_shapeChange;
    bool m_shapeChange_Exist;
    Mp7JrsnonNegativeRealPtr m_numOfNonTranspBlocks;
    bool m_numOfNonTranspBlocks_Exist;



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_ShapeHint_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1339MP7JRSMEDIATRANSCODINGHINTSTYPE_SHAPEHINT_LOCALTYPE_H

