/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _1390MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
#define _1390MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory<br>
 * for class Mp7JrsMixedCollectionType_Descriptor_CollectionType:<br>
 * Located at: mpeg7-2004.xsd, line 7889<br>
 * Abstract item type: DType<br>
 * Possible classes:<br>
 * \li AdvancedFaceRecognitionType (Class)<br>
 * \li AudioBPMType (Class)<br>
 * \li AudioFundamentalFrequencyType (Class)<br>
 * \li AudioHarmonicityType (Class)<br>
 * \li AudioPowerType (Class)<br>
 * \li AudioSpectrumBasisType (Class)<br>
 * \li AudioSpectrumCentroidType (Class)<br>
 * \li AudioSpectrumEnvelopeType (Class)<br>
 * \li AudioSpectrumFlatnessType (Class)<br>
 * \li AudioSpectrumProjectionType (Class)<br>
 * \li AudioSpectrumSpreadType (Class)<br>
 * \li AudioSummaryComponentType (Class)<br>
 * \li AudioWaveformType (Class)<br>
 * \li BackgroundNoiseLevelType (Class)<br>
 * \li BalanceType (Class)<br>
 * \li BandwidthType (Class)<br>
 * \li BrowsingPreferencesType_PreferenceCondition_LocalType (Class)<br>
 * \li CameraMotionType (Class)<br>
 * \li ColorLayoutType (Class)<br>
 * \li ColorSamplingType (Class)<br>
 * \li ColorStructureType (Class)<br>
 * \li ColorTemperatureType (Class)<br>
 * \li ContourShapeType (Class)<br>
 * \li CrossChannelCorrelationType (Class)<br>
 * \li DcOffsetType (Class)<br>
 * \li DominantColorType (Class)<br>
 * \li EdgeHistogramType (Class)<br>
 * \li FaceRecognitionType (Class)<br>
 * \li GoFGoPColorType (Class)<br>
 * \li HarmonicSpectralCentroidType (Class)<br>
 * \li HarmonicSpectralDeviationType (Class)<br>
 * \li HarmonicSpectralSpreadType (Class)<br>
 * \li HarmonicSpectralVariationType (Class)<br>
 * \li HomogeneousTextureType (Class)<br>
 * \li LogAttackTimeType (Class)<br>
 * \li MatchingHintType (Class)<br>
 * \li MediaFormatType (Class)<br>
 * \li MediaIdentificationType (Class)<br>
 * \li MediaQualityType (Class)<br>
 * \li MediaSpaceMaskType (Class)<br>
 * \li MediaTranscodingHintsType (Class)<br>
 * \li MeterType (Class)<br>
 * \li MotionActivityType (Class)<br>
 * \li MotionTrajectoryType (Class)<br>
 * \li OrderedGroupDataSetMaskType (Class)<br>
 * \li ParametricMotionType (Class)<br>
 * \li PointOfViewType (Class)<br>
 * \li PreferenceConditionType (Class)<br>
 * \li RegionShapeType (Class)<br>
 * \li RelativeDelayType (Class)<br>
 * \li ScalableColorType (Class)<br>
 * \li SceneGraphMaskType (Class)<br>
 * \li Shape3DType (Class)<br>
 * \li ShapeVariationType (Class)<br>
 * \li SilenceType (Class)<br>
 * \li SoundModelStateHistogramType (Class)<br>
 * \li SourcePreferencesType_MediaFormat_LocalType (Class)<br>
 * \li SpatialMaskType (Class)<br>
 * \li SpatioTemporalMaskType (Class)<br>
 * \li SpectralCentroidType (Class)<br>
 * \li StreamMaskType (Class)<br>
 * \li TemporalCentroidType (Class)<br>
 * \li TemporalMaskType (Class)<br>
 * \li TextualSummaryComponentType (Class)<br>
 * \li TextureBrowsingType (Class)<br>
 * \li VisualSummaryComponentType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory();
    virtual ~Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1390MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
