/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _1900MP7JRSSEMANTICBASETYPE_MEDIAOCCURRENCE_AUDIODESCRIPTOR_COLLECTIONTYPEFACTORY_H
#define _1900MP7JRSSEMANTICBASETYPE_MEDIAOCCURRENCE_AUDIODESCRIPTOR_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionTypeFactory<br>
 * for class Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType:<br>
 * Located at: mpeg7-2004.xsd, line 6775<br>
 * Abstract item type: AudioDType<br>
 * Possible classes:<br>
 * \li AudioBPMType (Class)<br>
 * \li AudioFundamentalFrequencyType (Class)<br>
 * \li AudioHarmonicityType (Class)<br>
 * \li AudioPowerType (Class)<br>
 * \li AudioSpectrumBasisType (Class)<br>
 * \li AudioSpectrumCentroidType (Class)<br>
 * \li AudioSpectrumEnvelopeType (Class)<br>
 * \li AudioSpectrumFlatnessType (Class)<br>
 * \li AudioSpectrumProjectionType (Class)<br>
 * \li AudioSpectrumSpreadType (Class)<br>
 * \li AudioWaveformType (Class)<br>
 * \li BackgroundNoiseLevelType (Class)<br>
 * \li BalanceType (Class)<br>
 * \li BandwidthType (Class)<br>
 * \li CrossChannelCorrelationType (Class)<br>
 * \li DcOffsetType (Class)<br>
 * \li HarmonicSpectralCentroidType (Class)<br>
 * \li HarmonicSpectralDeviationType (Class)<br>
 * \li HarmonicSpectralSpreadType (Class)<br>
 * \li HarmonicSpectralVariationType (Class)<br>
 * \li LogAttackTimeType (Class)<br>
 * \li MeterType (Class)<br>
 * \li RelativeDelayType (Class)<br>
 * \li SilenceType (Class)<br>
 * \li SoundModelStateHistogramType (Class)<br>
 * \li SpectralCentroidType (Class)<br>
 * \li TemporalCentroidType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionTypeFactory();
    virtual ~Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1900MP7JRSSEMANTICBASETYPE_MEDIAOCCURRENCE_AUDIODESCRIPTOR_COLLECTIONTYPEFACTORY_H
