/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2103MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE_H
#define _2103MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtInclude.h


class IMp7JrsMediaIncrDurationType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType;
typedef Mp7JrsPtr< IMp7JrsMediaIncrDurationType > Mp7JrsMediaIncrDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType> Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType for class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get TimeIncr element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetTimeIncr() const = 0;

    /**
     * Set TimeIncr element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MotionParams element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr GetMotionParams() const = 0;

    /**
     * Set MotionParams element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr &
     */
    virtual void SetMotionParams(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 209.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType :
        public IMp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get TimeIncr element.
     * @return Mp7JrsMediaIncrDurationPtr
     */
    virtual Mp7JrsMediaIncrDurationPtr GetTimeIncr() const;

    /*
     * Set TimeIncr element.
     * @param item const Mp7JrsMediaIncrDurationPtr &
     */
    virtual void SetTimeIncr(const Mp7JrsMediaIncrDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MotionParams element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr GetMotionParams() const;

    /*
     * Set MotionParams element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr &
     */
    virtual void SetMotionParams(const Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsMediaIncrDurationPtr m_TimeIncr;
    Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_MotionParams_CollectionPtr m_MotionParams;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_IntegratedCoordinateSystem_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2103MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_INTEGRATEDCOORDINATESYSTEM_LOCALTYPE_H

