/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2301MP7JRSSUBJECTTERMDEFINITIONTYPE_LOCALTYPE_H
#define _2301MP7JRSSUBJECTTERMDEFINITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSubjectTermDefinitionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtInclude.h


class IMp7JrsSubjectTermDefinitionType_Classification_CollectionType;
class IMp7JrsSubjectTermDefinitionType_LocalType;
class IMp7JrsSubjectTermDefinitionType_Note_CollectionType;
class IMp7JrsSubjectTermDefinitionType_Subdivision_CollectionType;
class IMp7JrsSubjectTermDefinitionType_Term_CollectionType;
typedef Mp7JrsPtr< IMp7JrsSubjectTermDefinitionType_Classification_CollectionType > Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSubjectTermDefinitionType_LocalType> Mp7JrsSubjectTermDefinitionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSubjectTermDefinitionType_Note_CollectionType > Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSubjectTermDefinitionType_Subdivision_CollectionType > Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSubjectTermDefinitionType_Term_CollectionType > Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr;

/** 
 * Generated interface IMp7JrsSubjectTermDefinitionType_LocalType for class Mp7JrsSubjectTermDefinitionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSubjectTermDefinitionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSubjectTermDefinitionType_LocalType();
    virtual ~IMp7JrsSubjectTermDefinitionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Classification element.
     * @return Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr GetClassification() const = 0;

    /**
     * Set Classification element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr &
     */
    virtual void SetClassification(const Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Subdivision element.
     * @return Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr GetSubdivision() const = 0;

    /**
     * Set Subdivision element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr &
     */
    virtual void SetSubdivision(const Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Note element.
     * @return Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr GetNote() const = 0;

    /**
     * Set Note element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr &
     */
    virtual void SetNote(const Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Term element.
     * @return Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr GetTerm() const = 0;

    /**
     * Set Term element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSubjectTermDefinitionType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 8971.<br>
 */
class MP7JRS_EXPORT Mp7JrsSubjectTermDefinitionType_LocalType :
        public IMp7JrsSubjectTermDefinitionType_LocalType
{
    friend class Mp7JrsSubjectTermDefinitionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Classification element.
     * @return Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr GetClassification() const;

    /*
     * Set Classification element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr &
     */
    virtual void SetClassification(const Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Subdivision element.
     * @return Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr GetSubdivision() const;

    /*
     * Set Subdivision element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr &
     */
    virtual void SetSubdivision(const Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Note element.
     * @return Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr GetNote() const;

    /*
     * Set Note element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr &
     */
    virtual void SetNote(const Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Term element.
     * @return Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr
     */
    virtual Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr GetTerm() const;

    /*
     * Set Term element.
     * @param item const Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr &
     */
    virtual void SetTerm(const Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSubjectTermDefinitionType_LocalType();

protected:
    Mp7JrsSubjectTermDefinitionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsSubjectTermDefinitionType_Classification_CollectionPtr m_Classification;
    Mp7JrsSubjectTermDefinitionType_Subdivision_CollectionPtr m_Subdivision;
    Mp7JrsSubjectTermDefinitionType_Note_CollectionPtr m_Note;
    Mp7JrsSubjectTermDefinitionType_Term_CollectionPtr m_Term;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSubjectTermDefinitionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2301MP7JRSSUBJECTTERMDEFINITIONTYPE_LOCALTYPE_H

