/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2783MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE3_H
#define _2783MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE3_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsWordFormType_type_LocalType3Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType3_ExtInclude.h


#include "Mp7JrsWordFormType_type_LocalType.h"
class IMp7JrsWordFormType_type_LocalType2;
class IMp7JrsWordFormType_type_LocalType3;
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_LocalType2 > Mp7JrsWordFormType_type_Local2Ptr;
typedef Mp7JrsPtr< IMp7JrsWordFormType_type_LocalType3> Mp7JrsWordFormType_type_LocalType3Ptr;

/** 
 * Generated interface IMp7JrsWordFormType_type_LocalType3 for class Mp7JrsWordFormType_type_LocalType3<br>
 * Located at: mpeg7-2004.xsd, line 3827<br>
 */
class MP7JRS_EXPORT IMp7JrsWordFormType_type_LocalType3 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsWordFormType_type_LocalType3();
    virtual ~IMp7JrsWordFormType_type_LocalType3();
    /** @name Union

     */
    //@{
    /**
     * Get Mp7JrsWordFormType_type_LocalType element.
     * @return Mp7JrsWordFormType_type_LocalType::Enumeration
     */
    virtual Mp7JrsWordFormType_type_LocalType::Enumeration GetWordFormType_type_LocalType() const = 0;

    /**
     * Set Mp7JrsWordFormType_type_LocalType element.
     * @param item Mp7JrsWordFormType_type_LocalType::Enumeration
     */
    // Mandatory			
    virtual void SetWordFormType_type_LocalType(Mp7JrsWordFormType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Mp7JrsWordFormType_type_LocalType2 element.
     * @return Mp7JrsWordFormType_type_Local2Ptr
     */
    virtual Mp7JrsWordFormType_type_Local2Ptr GetWordFormType_type_LocalType2() const = 0;

    /**
     * Set Mp7JrsWordFormType_type_LocalType2 element.
     * @param item const Mp7JrsWordFormType_type_Local2Ptr &
     */
    // Mandatory			
    virtual void SetWordFormType_type_LocalType2(const Mp7JrsWordFormType_type_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    //@}
// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType3_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType3_ExtPropDef.h

};




/*
 * Generated class Mp7JrsWordFormType_type_LocalType3<br>
 * Located at: mpeg7-2004.xsd, line 3827<br>
 * Defined in mpeg7-2004.xsd, line 3827.<br>
 */
class MP7JRS_EXPORT Mp7JrsWordFormType_type_LocalType3 :
        public IMp7JrsWordFormType_type_LocalType3
{
    friend class Mp7JrsWordFormType_type_LocalType3Factory; // constructs objects

public:
    /* @name Union

     */
    //@{
    /*
     * Get Mp7JrsWordFormType_type_LocalType element.
     * @return Mp7JrsWordFormType_type_LocalType::Enumeration
     */
    virtual Mp7JrsWordFormType_type_LocalType::Enumeration GetWordFormType_type_LocalType() const;

    /*
     * Set Mp7JrsWordFormType_type_LocalType element.
     * @param item Mp7JrsWordFormType_type_LocalType::Enumeration
     */
    // Mandatory			
    virtual void SetWordFormType_type_LocalType(Mp7JrsWordFormType_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Mp7JrsWordFormType_type_LocalType2 element.
     * @return Mp7JrsWordFormType_type_Local2Ptr
     */
    virtual Mp7JrsWordFormType_type_Local2Ptr GetWordFormType_type_LocalType2() const;

    /*
     * Set Mp7JrsWordFormType_type_LocalType2 element.
     * @param item const Mp7JrsWordFormType_type_Local2Ptr &
     */
    // Mandatory			
    virtual void SetWordFormType_type_LocalType2(const Mp7JrsWordFormType_type_Local2Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType3_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsWordFormType_type_LocalType3();

protected:
    Mp7JrsWordFormType_type_LocalType3();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionUnion
    Mp7JrsWordFormType_type_LocalType::Enumeration m_WordFormType_type_LocalType;
    Mp7JrsWordFormType_type_Local2Ptr m_WordFormType_type_LocalType2;
// End DefinionUnion

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType3_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2783MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE3_H

