/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// PatternType_H

#ifndef _283MP7JRSBASICDURATIONTYPE_H
#define _283MP7JRSBASICDURATIONTYPE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsbasicDurationTypeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrsbasicDurationType_ExtInclude.h



/**
 * Generated interface IMp7JrsbasicDurationType for Pattern Mp7JrsbasicDurationType
 */
class MP7JRS_EXPORT IMp7JrsbasicDurationType :
	public Mp7JrsNode
{
public:
	virtual int GetDurationSign() const = 0;

	virtual void SetDurationSign(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetDays() const = 0;

	virtual void SetDays(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetHours() const = 0;

	virtual void SetHours(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetMinutes() const = 0;

	virtual void SetMinutes(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetSeconds() const = 0;

	virtual void SetSeconds(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetNumberOfFractions() const = 0;

	virtual void SetNumberOfFractions(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetDecimalFractions() const = 0;

	virtual void SetDecimalFractions(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual bool GetTime_Exist() const = 0;

	virtual void SetTime_Exist(bool val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetFractionsPerSecond() const = 0;

	virtual void SetFractionsPerSecond(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual int GetTimezoneSign() const = 0;

	virtual void SetTimezoneSign(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual unsigned int GetTimezoneHours() const = 0;

	virtual void SetTimezoneHours(unsigned int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual unsigned int GetTimezoneMinutes() const = 0;

	virtual void SetTimezoneMinutes(unsigned int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	virtual bool GetTimezone_Exist() const = 0;

	virtual void SetTimezone_Exist(bool val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrsbasicDurationType_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrsbasicDurationType<br>
 * Located at: mpeg7-2004.xsd, line 74<br>
 * Regular expression: <br>
 * \-?P(\d+D)?(T(\d+H)?(\d+M)?(\d+S)?(\d+N)?(\d{2}f)?)?(\d+F)?((\-|\+)\d{2}:\d{2}Z)?<br>
 */
class MP7JRS_EXPORT Mp7JrsbasicDurationType :
	public IMp7JrsbasicDurationType
{
	friend class Mp7JrsbasicDurationTypeFactory;
	
public: 
	virtual int GetDurationSign() const;

	virtual void SetDurationSign(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetDays() const;

	virtual void SetDays(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetHours() const;

	virtual void SetHours(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetMinutes() const;

	virtual void SetMinutes(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetSeconds() const;

	virtual void SetSeconds(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetNumberOfFractions() const;

	virtual void SetNumberOfFractions(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetDecimalFractions() const;

	virtual void SetDecimalFractions(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual bool GetTime_Exist() const;

	virtual void SetTime_Exist(bool val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetFractionsPerSecond() const;

	virtual void SetFractionsPerSecond(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual int GetTimezoneSign() const;

	virtual void SetTimezoneSign(int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual unsigned int GetTimezoneHours() const;

	virtual void SetTimezoneHours(unsigned int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual unsigned int GetTimezoneMinutes() const;

	virtual void SetTimezoneMinutes(unsigned int val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	virtual bool GetTimezone_Exist() const;

	virtual void SetTimezone_Exist(bool val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);
	virtual bool ContentFromString(const XMLCh * const txt);

	virtual XMLCh * ContentToString() const;

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrsbasicDurationType_ExtMyMethodDef.h


	virtual ~Mp7JrsbasicDurationType();

protected:
	Mp7JrsbasicDurationType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	int m_DurationSign;
	int m_Days;
	int m_Hours;
	int m_Minutes;
	int m_Seconds;
	int m_NumberOfFractions;
	int m_DecimalFractions;
	bool m_Time_Exist;
	int m_FractionsPerSecond;
	int m_TimezoneSign;
	unsigned int m_TimezoneHours;
	unsigned int m_TimezoneMinutes;
	bool m_Timezone_Exist;

// no includefile for extension defined 
// file Mp7JrsbasicDurationType_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
	
protected:
    const XMLCh * const m_nsURI; // For namespace handling
};

#endif // _283MP7JRSBASICDURATIONTYPE_H

