/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _1687MP7JRSPHONETICALPHABETTYPE_H
#define _1687MP7JRSPHONETICALPHABETTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsphoneticAlphabetType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsphoneticAlphabetType<br>
 * Located at: mpeg7-2004.xsd, line 2076<br>
 * Enumerations: <br>
 * sampa (mapped to XML sampa) <br>
 * ipaSymbol (mapped to XML ipaSymbol) <br>
 * ipaNumber (mapped to XML ipaNumber) <br>
 * other (mapped to XML other) <br>
 */
class MP7JRS_EXPORT Mp7JrsphoneticAlphabetType
{
public:
	/** Mp7JrsphoneticAlphabetType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		sampa, // Mapped to sampa
		ipaSymbol, // Mapped to ipaSymbol
		ipaNumber, // Mapped to ipaNumber
		other, // Mapped to other
	};
	

// no includefile for extension defined 
// file Mp7JrsphoneticAlphabetType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsphoneticAlphabetType::Enumeration item);
	static Mp7JrsphoneticAlphabetType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsphoneticAlphabetType_ExtPropDef.h



};
#endif // _1687MP7JRSPHONETICALPHABETTYPE_H
